; TABSIZE = 14
;  #[ File Description:
;
; JPEG Decoder Routines (DSP56001)
;
;  1993 Brainstorm & Atari Corp.
;
;  #] File Description: 
;  #[ EQUates:

START	equ	$40			; Start of Program

PBC	equ	$ffe0			; Hardware EQUate
HCR	equ	$ffe8			; Hardware EQUate
HSR	equ	$ffe9			; Hardware EQUate
HRX	equ	$ffeb			; Hardware EQUate
HTX	equ	$ffeb			; Hardware EQUate
BCR	equ	$fffe			; Hardware EQUate
IPR	equ	$ffff			; Hardware EQUate

COS1_4	equ	.707106781			; Used in IDCT Tables
SIN1_4	equ	.707106781			; Used in IDCT Tables
COS1_8	equ	.923879532			; Used in IDCT Tables
SIN1_8	equ	.382683432			; Used in IDCT Tables
COS1_16	equ	.980785280			; Used in IDCT Tables
SIN1_16	equ	.195090322			; Used in IDCT Tables
COS5_16	equ	.555570233			; Used in IDCT Tables
SIN5_16	equ	.831469612			; Used in IDCT Tables

;  #] EQUates: 
;  #[ Start Up:

Start	equ	$40

	ORG	P:0
	jmp	Start

	ORG	P:START
JPEGDecoder	ori	#$3,mr
	movep	#>4,X:<<HCR			; Set HCIE Bit for DSPDEBUG
	movep	#$0c00,X:<<IPR
	movep	#>1,X:<<PBC
	movep	#>0,X:<<BCR
	and	#$2,mr
	movec	#-1,m0
	movec	#-1,m1
	movec	#-1,m2
	movec	#-1,m3
	movec	#-1,m4
	movec	#-1,m5
	movec	#-1,m6
	movec	#-1,m7

;  #] Start Up: 
;  #[ Decoder Init:

_FlushLoop	jclr	#0,X:<<HSR,_EndFlush
	movep	X:<<HRX,x0			; Flush Host Port
	jmp	_FlushLoop
_EndFlush

;  #] Decoder Init: 
;  #[ Main Loop:
;
; L:R0	Input Buffer
; X:R1	Expansion Structure
; X:R2	JPEG Structure
; L:R3	Quantization Matrix
;
MainLoop	move	#ExpBuffer1,x0		; Init. Expansion Pointers
	move	x0,X:Exp1Ptr
	move	#ExpBuffer2,x0
	move	x0,X:Exp2Ptr
	move	#ExpBuffer3,x0
	move	x0,X:Exp3Ptr
	move	#ExpBuffer4,x0
	move	x0,X:Exp4Ptr
_WaitOrder	jclr	#0,X:<<HSR,_WaitOrder
	movep	X:<<HRX,x0
	jset	#0,x0,JPEGControl		; New JPEG Command / MCU ???
DecodeMCU	move	#InitSize,r2			; MCU
	move	#OutputBuffer,r4
	do	X:(r2)+,_EndRec		; Loop on Number of Source Coefs. / 2
_WaitRec1	jclr	#0,X:<<HSR,_WaitRec1
	movep	X:<<HRX,Y:(r4)		; Even Coefs. in Y RAM
_WaitRec2	jclr	#0,X:<<HSR,_WaitRec2
	movep	X:<<HRX,X:(r4)+		; Odd Coefs. in X RAM
_EndRec	move	#OutputBuffer,r4
	movec	#$1f,m0
	move	#Exp1Magic,r1
	do	X:(r2)+,_EndDecodeMCU		; Loop on Number of Source Components (1 -> 4)
	do	X:(r2)+,_EndComp		; Number of Data Units in Component
	move		X:(r2),r3		; Get Component Quantisation Table
	movec	#$1f,m3
	move	#INBuffer,r0
	move		X:(r3),x0	Y:(r4),y0
	do	#$20,_EndQuant		; Data Unit Quantization (Output in INBuffer)
	mpy	x0,y0,a	X:(r4)+,x0	Y:(r3)+,y0
	move	a0,a1
	move		a,X:(r0)
	mpy	x0,y0,b	X:(r3),x0	Y:(r4),y0
	move	b0,b1
	move			b,Y:(r0)+
_EndQuant	move	r1,X:SaveR1			; Save Useful Registers
	move	r2,X:SaveR2
	move	r4,X:SaveR4
	jsr	IDCTDU			; IDCT on one Data Unit
	jsr	ExpandDU			; Expansion on One Data Unit
	move	X:SaveR1,r1			; Restore Registers
	move	X:SaveR2,r2
	move	X:SaveR4,r4
_EndComp	move	(r1)+			; Skip Current Expansion Magic and Pointer
	move	(r1)+
	move	(r2)+			; Skip Component Quantization Table Number
_EndDecodeMCU	jsr	ConvertMCU			; Convert MCU
	movec	#-1,m5
	jsr	SendMCU			; Send MCU
	jmp	MainLoop			; Finished with the MCU

;  #] Main Loop: 
;  #[ IDCT DU:
;	 #[ DCT Initialization:

IDCTDU	move	#INBuffer,r0			; in[0], in[1]
	move	#4,n0
	move	#INBuffer+1,r4		; in[2], in[3]
	move	#4,n4
	move	#INBuffer+2,r1		; in[4], in[5]
	move	#4,n1
	move	#INBuffer+3,r5		; in[6], in[7]
	move	#4,n5
	move	#OUTBuffer,r2
	move	#4,n6
	move	#IDCTXCoef3,r3		; Sine Coefficients
	movec	#4,m3
	move	#IDCTXCoef7,r7		; Sine Coefficients
	movec	#4,m7
	do	#2,_EndYPass
	do	#4,_EndXPass

;	 #] DCT Initialization: 
;	 #[ Monodimensional DCT Even Pass:

	move		X:(r0),x0	Y:(r7)+,y0	; 		in[0]	cos1/4
	mpy	x0,y0,a	X:(r1),x1	Y:(r7)+,y1	; in[0]*cos1/4	in[4]	sin1/4
	macr	x1,y1,a			; in[0]*cos1/4+in[4]*sin1/4
	mpy	x0,y1,a	a,X:(r0)		; in[0]*sin1/4	store tmp10
	macr	-x1,y0,a	X:(r4),x0	Y:(r3)+,y0	; in[0]*sin1/4-in[4]*cos1/4	in[2]	cos1/8
	mpy	x0,y0,a	a,X:(r1)		; in[2]*cos1/8	store tmp11
	move		X:(r5),x1	Y:(r3)+,y1	;		in[6]	sin1/8
	macr	x1,y1,a			; in[2]*cos1/8+in[6]*sin1/8
	mpy	x0,y1,a	a,X:(r4)		; in[2]*sin1/8	store tmp13
	macr	-x1,y0,a	X:(r3)+,x0	Y:(r4),y0	; in[2]*sin1/8-in[6]*cos1/8	cos1/4	in[3]
	mpy	y0,x0,a	a,X:(r5)		; in[3]*cos1/4	store tmp12
	move		X:(r7)+,x1	Y:(r1),y1	; 		sin1/4	in[5]
	macr	y1,x1,a			; in[3]*cos1/4+in[5]*sin1/4
	mpy	y0,x1,a	X:(r0),b	a,Y:(r4)	; in[3]*sin1/4	tmp10	store tmp30
	macr	-y1,x0,a		Y:(r0),y0	; in[3]*sin1/4-in[5]*cos1/4	in1
	tfr	b,a	X:(r4),b	a,Y:(r1)	; transfer tmp10	tmp13	store tmp31
	add	a,b	Y:(r4),x0		; tmp10+tmp13		tmp30
	subl	b,a	b,X:(r0)	x0,b	; tmp10-tmp30		store tmp20
	tfr	y0,a	a,X:(r4)		; store tmp23
	add	a,b	X:(r1),y1		; in1+tmp30		tmp11
	subl	b,a	X:(r5),b	b,Y:(r0)	; in1-tmp30		tmp12	store tmp40
	tfr	y1,a		a,Y:(r4)	; store tmp42
	add	a,b		Y:(r5),x0	; tmp11+tmp12			in7
	subl	b,a	b,X:(r1)		; tmp11-tmp12			store tmp21
	tfr	x0,a	a,X:(r5)	Y:(r1),b	; store tmp22		tmp31
	add	a,b		Y:(r0),y0	; in7+tmp31                               tmp40
	subl	b,a		b,Y:(r5)	; in7-tmp31			store tmp41
	move		X:(r7)+,x0	a,Y:(r1)	;		cos1/16	store tmp43
	mpy	x0,y0,a	X:(r3)+,x1	Y:(r5),y1	; tmp40*cos1/16	sin1/16	tmp41
	macr	x1,y1,a			; tmp40*cos1/16+tmp41*sin1/16
	mpy	x1,y0,a		a,Y:(r0)	; tmp40*sin1/16		store tmp50
	macr	-x0,y1,a	X:(r3)+,x0	Y:(r4),y0	; tmp40*sin1/16-tmp41*cos1/16
	mpy	x0,y0,a		a,Y:(r5)	; tmp42*cos5/16		store tmp51
	move		X:(r7)+,x1	Y:(r1),y1
	macr	x1,y1,a			; tmp42*cos5/16+tmp43*sin5/16
	mpy	x1,y0,a		a,Y:(r4)	; tmp42*sin5/16		store tmp52
	macr	-x0,y1,a	r2,r6		; tmp42*sin5/16-tmp43*cos5/16
	move			a,Y:(r1)	;			store tmp53
	move	L:(r0)+n0,ab
	add	a,b
	subl	b,a	b,X:(r6)+n6
	move	a,x0
	move	L:(r1)+n1,ab
	add	a,b
	subl	b,a	b,X:(r6)+n6
	move		X:(r5),a	a,y1
	move			Y:(r4),b
	add	a,b
	subl	b,a	b,X:(r6)+n6
	move		X:(r4)+n4,a	a,y0
	move			Y:(r5)+n5,b
	add	a,b
	subl	b,a	b,X:(r6)+n6
	move		a,X:(r6)+n6
	move		y0,X:(r6)+n6
	move		y1,X:(r6)+n6
	move		x0,X:(r6)+n6

;	 #] Monodimensional DCT Even Pass: 
;	 #[ Monodimensional DCT Odd Pass:

	move		X:(r0),x0	Y:(r7)+,y0	; 		in[0]	cos1/4
	mpy	x0,y0,a	X:(r1),x1	Y:(r7)+,y1	; in[0]*cos1/4	in[4]	sin1/4
	macr	x1,y1,a			; in[0]*cos1/4+in[4]*sin1/4
	mpy	x0,y1,a	a,X:(r0)		; in[0]*sin1/4	store tmp10
	macr	-x1,y0,a	X:(r4),x0	Y:(r3)+,y0	; in[0]*sin1/4-in[4]*cos1/4	in[2]	cos1/8
	mpy	x0,y0,a	a,X:(r1)		; in[2]*cos1/8	store tmp11
	move		X:(r5),x1	Y:(r3)+,y1	;		in[6]	sin1/8
	macr	x1,y1,a			; in[2]*cos1/8+in[6]*sin1/8
	mpy	x0,y1,a	a,X:(r4)		; in[2]*sin1/8	store tmp13
	macr	-x1,y0,a	X:(r3)+,x0	Y:(r4),y0	; in[2]*sin1/8-in[6]*cos1/8	cos1/4	in[3]
	mpy	y0,x0,a	a,X:(r5)		; in[3]*cos1/4	store tmp12
	move		X:(r7)+,x1	Y:(r1),y1	; 		sin1/4	in[5]
	macr	y1,x1,a			; in[3]*cos1/4+in[5]*sin1/4
	mpy	y0,x1,a	X:(r0),b	a,Y:(r4)	; in[3]*sin1/4	tmp10	store tmp30
	macr	-y1,x0,a		Y:(r0),y0	; in[3]*sin1/4-in[5]*cos1/4               in1
	tfr	b,a	X:(r4),b	a,Y:(r1)	; transfer tmp10	tmp13	store tmp31
	add	a,b	Y:(r4),x0		; tmp10+tmp13		tmp30
	subl	b,a	b,X:(r0)	x0,b	; tmp10-tmp30		store tmp20
	tfr	y0,a	a,X:(r4)		; store tmp23
	add	a,b	X:(r1),y1		; in1+tmp30		tmp11
	subl	b,a	X:(r5),b	b,Y:(r0)	; in1-tmp30		tmp12	store tmp40
	tfr	y1,a		a,Y:(r4)	; store tmp42
	add	a,b		Y:(r5),x0	; tmp11+tmp12			in7
	subl	b,a	b,X:(r1)		; tmp11-tmp12			store tmp21
	tfr	x0,a	a,X:(r5)	Y:(r1),b	; store tmp22		tmp31
	add	a,b		Y:(r0),y0	; in7+tmp31                               tmp40
	subl	b,a		b,Y:(r5)	; in7-tmp31			store tmp41
	move		X:(r7)+,x0	a,Y:(r1)	;		cos1/16	store tmp43
	mpy	x0,y0,a	X:(r3)+,x1	Y:(r5),y1	; tmp40*cos1/16	sin1/16	tmp41
	macr	x1,y1,a			; tmp40*cos1/16+tmp41*sin1/16
	mpy	x1,y0,a		a,Y:(r0)	; tmp40*sin1/16		store tmp50
	macr	-x0,y1,a	X:(r3)+,x0	Y:(r4),y0	; tmp40*sin1/16-tmp41*cos1/16
	mpy	x0,y0,a		a,Y:(r5)	; tmp42*cos5/16		store tmp51
	move		X:(r7)+,x1	Y:(r1),y1
	macr	x1,y1,a			; tmp42*cos5/16+tmp43*sin5/16
	mpy	x1,y0,a		a,Y:(r4)	; tmp42*sin5/16		store tmp52
	macr	-x0,y1,a	r2,r6		; tmp42*sin5/16-tmp43*cos5/16
	move			a,Y:(r1)	;			store tmp53
	move	L:(r0)+n0,ab
	add	a,b
	subl	b,a	b,Y:(r6)+n6
	move	a,x0
	move	L:(r1)+n1,ab
	add	a,b
	subl	b,a	b,Y:(r6)+n6
	move		X:(r5),a	a,y1
	move			Y:(r4),b
	add	a,b
	subl	b,a	b,Y:(r6)+n6
	move		X:(r4)+n4,a	a,y0
	move			Y:(r5)+n5,b
	add	a,b	(r2)+
	subl	b,a	b,Y:(r6)+n6
	move		a,Y:(r6)+n6
	move		y0,Y:(r6)+n6
	move		y1,Y:(r6)+n6
	move		x0,Y:(r6)+n6

;	 #] Monodimensional DCT Odd Pass: 
;	 #[ DCT End Pass:

_EndXPass	move	#OUTBuffer,r0
	move	#OUTBuffer+1,r4
	move	#OUTBuffer+2,r1
	move	#OUTBuffer+3,r5
	move	#INBuffer,r2
_EndYPass	rts

;	 #] DCT End Pass: 
;  #] IDCT DU: 
;  #[ Convert MCU:
;	 #[ Convert Switch:

ConvertMCU	move	#ColorTable,r0
	move	X:ColorMagic,n0
	nop
	move	X:(r0+n0),r0
	nop
	jmp	(r0)

;	 #] Convert Switch: 
;	 #[ Y To Y:

YToY	move	X:FinalSize,x1
	move	#ExpBuffer1,r0
	movec	#-1,m0
	move	#OutputBuffer,r4
	move	#(0.5/4096),y1
	do	x1,_EndLoop
	move		X:(r0),x0
	mpyr	y1,x0,a		Y:(r0)+,y0
	mpyr	y1,y0,a		a,Y:(r4)
	move		a,X:(r4)+
_EndLoop	rts

;	 #] Y To Y: 
;	 #[ Y To RGB:

YToRGB	move	X:FinalSize,x1
	move	#ExpBuffer1,r0
	movec	#-1,m0
	move	#OutputBuffer,r4
	move	#OutputBuffer,r1
	move	#(0.5/4096),y1
	do	x1,_EndLoop
	move			Y:(r0),x0
	mpyr	y1,x0,a
	move		a,X:(r1)+	a,Y:(r4)+
	move		X:(r0)+,x0
	mpyr	y1,x0,a		a,X:(r1)+
	move		a,X:(r1)+	a,Y:(r4)+
	move			a,Y:(r4)+
_EndLoop	rts

;	 #] Y To RGB: 
;	 #[ YCbCr To Y:

YCbCrToY	jmp	YToY

;	 #] YCbCr To Y: 
;	 #[ YCbCr To RGB:

YCbCrToRGB	move	X:FinalSize,x1
	move	#ExpBuffer1,r0
	movec	#-1,m0
	move	#ExpBuffer2,r1
	move	#ExpBuffer3,r2
	move	#OutputBuffer,r4
	move	#RGBMatrix,r5
	movec	#4,m5
	ori	#8,mr
	do	x1,_EndLoop
	move		X:(r5)+,x0	Y:(r0),y0
	mpy	x0,y0,b
	tfr	b,a	X:(r5)+,x0	Y:(r2),y0
	macr	x0,y0,a	X:(r5)+,x0	Y:(r1),y0
	tfr	b,a	a,X:(r4)
	mac	-x0,y0,a	X:(r5)+,x0	Y:(r2),y0
	macr	-x0,y0,a	X:(r5)+,x0	Y:(r1),y0
	macr	x0,y0,b		a,Y:(r4)+
	move		X:(r0)+,x0	Y:(r5)+,y0
	mpy	x0,y0,a	b,X:(r4)
	tfr	a,b	X:(r2),x0	Y:(r5)+,y0
	macr	x0,y0,b	X:(r1),x0	Y:(r5)+,y0
	tfr	a,b		b,Y:(r4)+
	mac	-x0,y0,b	X:(r2)+,x0	Y:(r5)+,y0
	macr	-x0,y0,b	X:(r1)+,x0	Y:(r5)+,y0
	macr	x0,y0,a		b,X:(r4)
	move			a,Y:(r4)+
_EndLoop	andi	#$f3,mr
	rts

;	 #] YCbCr To RGB: 
;  #] Convert MCU: 
;  #[ Expand DU:		; *
;	 #[ Expand Switch:

ExpandDU	move	X:SaveR1,r1
	move	#ExpTable,r5
	move	X:(r1)+,n5
	move	X:(r1),r4
	move	X:(r5+n5),r5
	move	#INBuffer,r0
	jsr	(r5)
	move	r4,X:(r1)-
	rts

;	 #] Expand Switch: 
;	 #[ X1, Y1:
;
; MonoChannel / MultiChannel
;
X1Y1_X1Y1	move	r4,r5
	move		X:(r0)+,a
	rep	#$1f
	move		X:(r0)+,a	a,Y:(r4)+
	move			a,Y:(r4)+
	move			Y:(r0)+,a
	rep	#$1f
	move		a,X:(r5)+	Y:(r0)+,a
	move		a,X:(r5)+
	rts

;	 #] X1, Y1: 
;	 #[ X1, Y2:
;
; MonoChannel / MultiChannel
;
X1Y2_X1Y1	jmp	X1Y1_X1Y1

X1Y2_X1Y2	movec	#3,m0
	move	#4,n0
	move	r4,r2
	do	#8,_EndLoop1
	do	#8,_EndLoop2
	move	L:(r0)+,ab
	move		b,X:(r4)+	a,Y:(r2)+
_EndLoop2	move	(r0)+n0
_EndLoop1	movec	#$1f,m0
	rts

;	 #] X1, Y2: 
;	 #[ X1, Y3:
;
; MonoChannel / MultiChannel
;
X1Y3_X1Y1	jmp	X1Y1_X1Y1

X1Y3_X1Y3	movec	#3,m0
	move	#4,n0
	move	r4,r2
	do	#8,_EndLoop1
	do	#$c,_EndLoop2
	move	L:(r0)+,ab
	move		b,X:(r4)+	a,Y:(r2)+
_EndLoop2	move	(r0)+n0
_EndLoop1	movec	#$1f,m0
	rts

;	 #] X1, Y3: 
;	 #[ X1, Y4:
;
; MonoChannel / MultiChannel
;
X1Y4_X1Y1	jmp	X1Y1_X1Y1

X1Y4_X1Y2	jmp	X1Y2_X1Y2

X1Y4_X1Y4	movec	#3,m0
	move	#4,n0
	move	r4,r2
	do	#8,_EndLoop1
	do	#$10,_EndLoop2
	move	L:(r0)+,ab
	move		b,X:(r4)+	a,Y:(r2)+
_EndLoop2	move	(r0)+n0
_EndLoop1	movec	#$1f,m0
	rts

;	 #] X1, Y4: 
;	 #[ X2, Y1:
;
; MonoChannel / MultiChannel
;
X2Y1_X1Y1	jmp	X1Y1_X1Y1

X2Y1_X2Y1	move	#3,n0
	move	r4,r2
	do	#2,_EndLoop1
	do	#8,_EndLoop2
	move	L:(r0)+,ab
	move		a,X:(r4)+	a,Y:(r2)+
	move		b,X:(r4)+	b,Y:(r2)+
	move	L:(r0)+n0,ab
	move		a,X:(r4)+	a,Y:(r2)+
	move		b,X:(r4)+	b,Y:(r2)+
_EndLoop2	move	(r0)+
	move	(r0)+
_EndLoop1	rts

;	 #] X2, Y1: 
;	 #[ X2, Y2:
;
; MonoChannel / MultiChannel
;
X2Y2_X1Y1	jmp	X1Y1_X1Y1

X2Y2_X1Y2	movec	#3,m0
	move	#4,n0
	move	#$40,n4
	move	#4,n2
	do	#2,_EndLoop1
	move	r4,r2
	nop
	lua	(r2)+n2,r5
	do	#4,_EndLoop2
	do	#8,_EndLoop3
	move	L:(r0)+,ab
	move		b,X:(r5)	a,Y:(r2)
	move		b,X:(r2)+	a,Y:(r5)+
_EndLoop3	move	(r0)+n0
_EndLoop2	move	(r4)+n4
_EndLoop1	move	#$60,n4
	movec	#$1f,m0
	move	(r4)-n4
	rts

X2Y2_X2Y1	jmp	X2Y1_X2Y1

X2Y2_X2Y2	move	#2,n0
	move	#4,n2
	move	#4,n5
	move	#$40,n4
	move	r4,r6
	move	#$20,n6
	do	#2,_EndLoop1
	move	r4,r2
	nop
	lua	(r2)+n2,r5
	do	#2,_EndLoop2
	do	#4,_EndLoop3
	move	L:(r0)+,ab
	move		a,X:(r2)	a,Y:(r5)
	move		a,X:(r5)+	a,Y:(r2)+
	move		b,X:(r2)	b,Y:(r5)
	move		b,X:(r5)+	b,Y:(r2)+
	move	L:(r0)+,ab
	move		a,X:(r2)	a,Y:(r5)
	move		a,X:(r5)+	a,Y:(r2)+
	move		b,X:(r2)	b,Y:(r5)
	move		b,X:(r5)+	b,Y:(r2)+
	move	(r0)+n0
	move		X:(r2)+n2,a	Y:(r5)+n5,b
_EndLoop3	lua	(r4)+n4,r5
	lua	(r4)+n4,r2
	move	(r5)+n5
_EndLoop2	move	(r0)+n0
	lua	(r6)+n6,r4
_EndLoop1	move	#$80,n6
	nop
	lua	(r6)+n6,r4
	rts

;	 #] X2, Y2: 
;	 #[ X2, Y3:		; *
;
; MonoChannel / MultiChannel
;
X2Y3_X1Y1	jmp	X1Y1_X1Y1

X2Y3_X1Y3	rts

X2Y3_X2Y1	jmp	X2Y1_X2Y1

X2Y3_X2Y3	rts

;	 #] X2, Y3: 
;	 #[ X2, Y4:		; *
;
; MonoChannel / MultiChannel
;
X2Y4_X1Y1	jmp	X1Y1_X1Y1

X2Y4_X1Y2	rts

X2Y4_X1Y4	rts

X2Y4_X2Y1	jmp	X2Y4_X2Y1

X2Y4_X2Y2	jmp	X2Y2_X2Y2

X2Y4_X2Y4	rts

;	 #] X2, Y4: 
;	 #[ X3, Y1:		; *
;
; MonoChannel / MultiChannel
;
X3Y1_X1Y1	jmp	X1Y1_X1Y1

X3Y1_X3Y1	rts

;	 #] X3, Y1: 
;	 #[ X3, Y2:		; *
;
; MonoChannel / MultiChannel
;
X3Y2_X1Y1	jmp	X1Y1_X1Y1

X3Y2_X1Y2	rts

X3Y2_X3Y1	rts

X3Y2_X3Y2	rts

;	 #] X3, Y2: 
;	 #[ X3, Y3:		; *
;
; MonoChannel / MultiChannel
;
X3Y3_X1Y1	jmp	X1Y1_X1Y1

X3Y3_X1Y3	rts

X3Y3_X3Y1	jmp	X3Y2_X3Y1

X3Y3_X3Y3	rts

;	 #] X3, Y3: 
;	 #[ X3, Y4:		; *
;
; MonoChannel Only
;
X3Y4_X3Y4	rts

;	 #] X3, Y4: 
;	 #[ X4, Y1:
;
; MonoChannel / MultiChannel
;
X4Y1_X1Y1	jmp	X1Y1_X1Y1

X4Y1_X2Y1	jmp	X2Y1_X2Y1

X4Y1_X4Y1	move	#4,n0
	move	r4,r2
	do	#4,_EndLoop1
	do	#8,_EndLoop2
	move	L:(r0)+n0,ab
	move		a,X:(r4)+	a,Y:(r2)+
	move		a,X:(r4)+	a,Y:(r2)+
	move		b,X:(r4)+	b,Y:(r2)+
	move		b,X:(r4)+	b,Y:(r2)+
_EndLoop2	move	(r0)+
_EndLoop1	rts

;	 #] X4, Y1: 
;	 #[ X4, Y2:		; *
;
; MonoChannel / MultiChannel
;
X4Y2_X1Y1	jmp	X1Y1_X1Y1

X4Y2_X1Y2	rts

X4Y2_X2Y1	rts

X4Y2_X2Y2	rts

X4Y2_X4Y1	jmp	X4Y1_X4Y1

X4Y2_X4Y2	rts

;	 #] X4, Y2: 
;	 #[ X4, Y3:		; *
;
; MonoChannel Only
;
X4Y3_X4Y3	rts

;	 #] X4, Y3: 
;	 #[ X4, Y4:		; *
;
; MonoChannel Only
;
X4Y4_X4Y4	rts

;	 #] X4, Y4: 
;  #] Expand DU: 
;  #[ Send MCU:
;	 #[ Send Switch:

SendMCU	move	#SendTable,r0
	move	X:SendMagic,n0
	nop
	move		X:(r0+n0),r0
	nop
	jmp	(r0)

;	 #] Send Switch: 
;	 #[ Send 8 Bits Y:

Send8BitsY	move	#OutputBuffer,r0
	movec	#-1,m0
	move	#Gamma1Ptr,r4
	move	X:FinalSize,x1
	do	x1,_EndSend
	move		X:(r0),n4
_Wait1	jclr	#1,X:<<HSR,_Wait1
	movep	Y:(r4+n4),X:<<HRX		; Luma 1
	move			Y:(r0)+,n4
_Wait2	jclr	#1,X:<<HSR,_Wait2
	movep	Y:(r4+n4),X:<<HRX		; Luma 2
_EndSend	rts

;	 #] Send 8 Bits Y: 
;	 #[ Send 16 Bits RGB:

Send16BitsRGB	move	#OutputBuffer,r0
	movec	#-1,m0
	move	#Gamma1Ptr,r4
	move	#Gamma2Ptr,r5
	move	#Gamma3Ptr,r6
	move	X:FinalSize,x1
	do	x1,_EndSend
	move		X:(r0),n4
	move			Y:(r0)+,n5
	move		X:(r0),n6
	clr	a		Y:(r4+n4),x0	; Red 1
	or	x0,a		Y:(r5+r5),x0	; Green 1
	or	x0,a		Y:(r6+n6),x0	; Blue 1
	or	x0,a
_Wait1	jclr	#1,X:<<HSR,_Wait1
	movep	a,X:<<HRX			; RGB 1
	move			Y:(r0)+,n4
	move		X:(r0),n5
	move			Y:(r0)+,n6
	clr	a		Y:(r4+n4),x0	; Red 1
	or	x0,a		Y:(r5+r5),x0	; Green 1
	or	x0,a		Y:(r6+n6),x0	; Blue 1
	or	x0,a
_Wait2	jclr	#1,X:<<HSR,_Wait2
	movep	a,X:<<HRX			; RGB 2
_EndSend	rts

;	 #] Send 16 Bits RGB: 
;	 #[ Send 24 Bits RGB:

Send24BitsRGB	move	#OutputBuffer,r0
	movec	#-1,m0
	move	#Gamma1Ptr,r4
	move	#Gamma2Ptr,r5
	move	#Gamma3Ptr,r6
	move	X:FinalSize,x1
	do	x1,_EndSend
	move		X:(r0),n4
_Wait1	jclr	#1,X:<<HSR,_Wait1
	movep	Y:(r4+n4),X:<<HRX		; Red 1
	move			Y:(r0)+,n5
_Wait2	jclr	#1,X:<<HSR,_Wait2
	movep	Y:(r5+n5),X:<<HRX		; Green 1
	move		X:(r0),n6
_Wait3	jclr	#1,X:<<HSR,_Wait3
	movep	Y:(r6+n6),X:<<HRX		; Blue 1
	move			Y:(r0)+,n4
_Wait4	jclr	#1,X:<<HSR,_Wait4
	movep	Y:(r4+n4),X:<<HRX		; Red 2
	move		X:(r0),n5
_Wait5	jclr	#1,X:<<HSR,_Wait5
	movep	Y:(r5+n5),X:<<HRX		; Green 2
	move			Y:(r0)+,n6
_Wait6	jclr	#1,X:<<HSR,_Wait6
	movep	Y:(r6+n6),X:<<HRX		; Blue 2
_EndSend	rts

;	 #] Send 24 Bits RGB: 
;	 #[ Send 32 Bits RGB:

Send32BitsRGB	move	#OutputBuffer,r0
	movec	#-1,m0
	move	#Gamma1Ptr,r4
	move	#Gamma2Ptr,r5
	move	#Gamma3Ptr,r6
	clr	a	X:FinalSize,x1
	do	x1,_EndSend
_Wait1	jclr	#1,X:<<HSR,_Wait1
	movep	a,X:<<HRX			; 0
	move		X:(r0),n4
_Wait2	jclr	#1,X:<<HSR,_Wait2
	movep	Y:(r4+n4),X:<<HRX		; Red 1
	move			Y:(r0)+,n5
_Wait3	jclr	#1,X:<<HSR,_Wait3
	movep	Y:(r5+n5),X:<<HRX		; Green 1
	move		X:(r0),n6
_Wait4	jclr	#1,X:<<HSR,_Wait4
	movep	Y:(r6+n6),X:<<HRX		; Blue 1
_Wait5	jclr	#1,X:<<HSR,_Wait5
	movep	a,X:<<HRX			; 0
	move			Y:(r0)+,n4
_Wait6	jclr	#1,X:<<HSR,_Wait6
	movep	Y:(r4+n4),X:<<HRX		; Red 2
	move		X:(r0),n5
_Wait7	jclr	#1,X:<<HSR,_Wait7
	movep	Y:(r5+n5),X:<<HRX		; Green 2
	move			Y:(r0)+,n6
_Wait8	jclr	#1,X:<<HSR,_Wait8
	movep	Y:(r6+n6),X:<<HRX		; Blue 2
_EndSend	rts

;	 #] Send 32 Bits RGB: 
;  #] Send MCU: 
;  #[ JPEG Control Command:

JPEGControl	jset	#1,x0,JPEGGamma
;
; ... (JPEGSetStruct)
;
;  #] JPEG Control Command: 
;  #[ JPEG Set Structure:

JPEGSetStruct	move	#QuantMatrix1,r0
	do	#$80,_EndMatrix
_Wait1	jclr	#0,X:<<HSR,_Wait1
	movep	X:<<HRX,X:(r0)
_Wait2	jclr	#0,X:<<HSR,_Wait2
	movep	X:<<HRX,Y:(r0)+
_EndMatrix	move	#InitSize,r0
	do	#$d,_EndLoop1
_Wait3	jclr	#0,X:<<HSR,_Wait3
	movep	X:<<HRX,X:(r0)+
_EndLoop1	move	#Exp1Magic,r0
	do	#4,_EndLoop2
_Wait4	jclr	#0,X:HSR,_Wait4
	movep	X:<<HRX,X:(r0)+
	move	(r0)+
_EndLoop2	jmp	MainLoop

;  #] JPEG Set Structure: 
;  #[ JPEG Gamma Table:

JPEGGamma	jclr	#0,X:<<HSR,JPEGGamma
	movep	X:<<HRX,r0			; Gamma Table Address
	do	#$200,_EndLoop
_Wait	jclr	#0,X:<<HSR,_Wait
	movep	X:<<HRX,Y:(r0)+
_EndLoop	jmp	MainLoop

;  #] JPEG Gamma Table: 
;  #[ DCT Buffers:

	ORG	L:$00
INBuffer	equ	*

	ORG	L:$20
OUTBuffer	equ	*

;  #] DCT Buffers: 
;  #[ Quantization Buffers:

	ORG	L:$40
QuantMatrix1	equ	*

	ORG	L:$60
QuantMatrix2	equ	*

	ORG	L:$80
QuantMatrix3	equ	*

	ORG	L:$a0
QuantMatrix4	equ	*

;  #] Quantization Buffers: 
;  #[ DCT Coefficients:

	ORG	X:$c0
IDCTXCoef3	dc	0
	dc	0
	dc	COS1_4
	dc	SIN1_16/2
	dc	COS5_16/2

	ORG	X:$c8
IDCTXCoef7	dc	0
	dc	0
	dc	SIN1_4
	dc	COS1_16/2
	dc	SIN5_16/2

	ORG	Y:$c0
IDCTYCoef3	dc	COS1_8/2
	dc	SIN1_8/2
	dc	0
	dc	0
	dc	0

	ORG	Y:$c8
IDCTYCoef7	dc	COS1_4/2
	dc	SIN1_4/2
	dc	0
	dc	0
	dc	0

;  #] DCT Coefficients: 
;  #[ Color Space Table:

	ORG	X:$d0
ColorTable	dc	YToY
	dc	YToRGB
	dc	YCbCrToY
	dc	YCbCrToRGB

;  #] Color Space Table: 
;  #[ Block Expansion Table:

	ORG	X:$d4
ExpTable	dc	X1Y1_X1Y1
	dc	X1Y2_X1Y1,X1Y2_X1Y2
	dc	X1Y3_X1Y1,X1Y3_X1Y3
	dc	X1Y4_X1Y1,X1Y4_X1Y2,X1Y4_X1Y4
	dc	X2Y1_X1Y1,X2Y1_X2Y1
	dc	X2Y2_X1Y1,X2Y2_X1Y2,X2Y2_X2Y1,X2Y2_X2Y2
	dc	X2Y3_X1Y1,X2Y3_X1Y3,X2Y3_X2Y1,X2Y3_X2Y3
	dc	X2Y4_X1Y1,X2Y4_X1Y2,X2Y4_X1Y4,X2Y4_X2Y1,X2Y4_X2Y2,X2Y4_X2Y4
	dc	X3Y1_X1Y1,X3Y1_X3Y1
	dc	X3Y2_X1Y1,X3Y2_X1Y2,X3Y2_X3Y1,X3Y2_X3Y2
	dc	X3Y3_X1Y1,X3Y3_X1Y3,X3Y3_X3Y1,X3Y3_X3Y3
	dc	X3Y4_X3Y4
	dc	X4Y1_X1Y1,X4Y1_X2Y1,X4Y1_X4Y1
	dc	X4Y2_X1Y1,X4Y2_X1Y2,X4Y2_X2Y1,X4Y2_X2Y2,X4Y2_X4Y1,X4Y2_X4Y2
	dc	X4Y3_X4Y3
	dc	X4Y4_X4Y4

;  #] Block Expansion Table: 
;  #[ Color Space Coefficients:

	ORG	X:$108
RGBMatrix	dc	0.50000/8192			; (1.00000/2)>>13
	dc	0.70100/8192			; (1.40200/2)>>13
	dc	0.17207/8192			; (0.34414/2)>>13
	dc	0.35707/8192			; (0.71414/2)>>13
	dc	0.88600/8192			; (1.77200/2)>>13

	ORG	Y:$108
	dc	0.50000/8192			; (1.00000/2)>>13
	dc	0.70100/8192			; (1.40200/2)>>13
	dc	0.17207/8192			; (0.34414/2)>>13
	dc	0.35707/8192			; (0.71414/2)>>13
	dc	0.88600/8192			; (1.77200/2)>>13

;  #] Color Space Coefficients: 
;  #[ Send MCU Table:

	ORG	X:$110
SendTable	dc	Send8BitsY
	dc	Send16BitsRGB
	dc	Send24BitsRGB
	dc	Send32BitsRGB

;  #] Send MCU Table: 
;  #[ Decoder Structure:

	ORG	X:$180
InitSize	dc	0			; Number of Source Coefficients / 2
SrcCompNb	dc	0			; Number of Source Components (1, 2, 3, 4)
Comp1DU	dc	0			; Number of Data Units in Component 1
Comp1DQT	dc	0			; Component 1 Quantization Table (0, 1, 2, 3)
Comp2DU	dc	0			; Number of Data Units in Component 2
Comp2DQT	dc	0			; Component 2 Quantization Table (0, 1, 2, 3)
Comp3DU	dc	0			; Number of Data Units in Component 3
Comp3DQT	dc	0			; Component 3 Quantization Table (0, 1, 2, 3)
Comp4DU	dc	0			; Number of Data Units in Component 4
Comp4DQT	dc	0			; Component 4 Quantization Table (0, 1, 2, 3)
FinalSize	dc	0			; Component Final Size / 2
ColorMagic	dc	0			; Color Space Conversion Magic
SendMagic	dc	0			; Send MCU Magic

;  #] Decoder Structure: 
;  #[ Expansion Structure:

Exp1Magic	dc	0
Exp1Ptr	dc	ExpBuffer1
Exp2Magic	dc	0
Exp2Ptr	dc	ExpBuffer2
Exp3Magic	dc	0
Exp3Ptr	dc	ExpBuffer3
Exp4Magic	dc	0
Exp4Ptr	dc	ExpBuffer4

;  #] Expansion Structure: 
;  #[ Registers Buffers:

SaveR1	dc	0
SaveR2	dc	0
SaveR4	dc	0

;  #] Registers Buffers: 
;  #[ Expansion Buffers:

	ORG	L:$1000
ExpBuffer1	equ	*

	ORG	L:$1200
ExpBuffer2	equ	*

	ORG	L:$1400
ExpBuffer3	equ	*

	ORG	L:$1600
ExpBuffer4	equ	*

;  #] Expansion Buffers: 
;  #[ Output Buffer:

	ORG	L:$1800
OutputBuffer	equ	*

;  #] Output Buffer: 
;  #[ Gamma Buffers:

	ORG	Y:$2000			; Gamma Table 1
GammaTable1	equ	*
Gamma1Ptr	equ	*+$100

	ORG	Y:$2200			; Gamma Table 2
GammaTable2	equ	*
Gamma2Ptr	equ	*+$100

	ORG	Y:$2400			; Gamma Table 3
GammaTable3	equ	*
Gamma3Ptr	equ	*+$100

	ORG	Y:$2600			; Gamma Table 4
GammaTable4	equ	*
Gamma4Ptr	equ	*+$100

;  #] Gamma Buffers: 
 END
