; TABSIZE = 8
;  #[ File Description:
;
; JPEG Decoder Cookie Driver (MC68030 Only)
;
;      1993 Brainstorm & Atari Corp.
;
;  #] File Description: 
 TEXT
;  #[ Assembly Options:

 opt c+,o+,p=68030,w+

 output JPEGD.PRG

;  #] Assembly Options: 
;  #[ Includes:

 include JPEGD.I			; Program Structures & EQUates

;  #] Includes: 
;  #[ MC68030 Padding:

TEXTSTART:

;  #] MC68030 Padding: 
;  #[ Start Up:

StartUp:
 move.l 4(sp),a5
 lea MyStack(pc),sp
 move.l $c(a5),d7			; TEXT
 add.l $14(a5),d7			; + DATA
 add.l $1c(a5),d7			; + BSS
 add.l #$100,d7				; + BasePage
 move.l d7,-(sp)
 move.l a5,-(sp)
 clr.w -(sp)
 move.w #$4a,-(sp)
 trap #1				; Mshrink
 lea $c(sp),sp
 move.l #DecoderReadyTxt,TOSStringPtr	; Init TOS Default Message
 move.l #RsString2,RsTedinfo2		; Init GEM default Message
 bsr TestHardware			; Test DSP (24 Bits/Word)+ CPU (68020 or Higher)
 bmi .InvalidHardware
 bsr InstallCookie			; Install JPEG Decoder Cookie
 bmi .CookieError
 move.l a0,a1				; JPEG Decoder Cookie Address
 move.w #$40,ProtectionMode		; World-Readable Mode
 moveq #CookieStruct,d0
 bsr Malloc				; Allocate Cookie Structure
 bmi .MemoryError
 move.l a0,4(a1)			; Put JPEG Structure Pointer on Cookie Parameter
 move.l #VERSION,(a0)			; Fill Cookie Structure
 move.l #JPEGOpenDriver,CookieOpenDriver(a0)
 move.l #JPEGCloseDriver,CookieCloseDriver(a0)
 move.l #JPEGGetStructSize,CookieGetStructSize(a0)
 move.l #JPEGGetImageInfo,CookieGetImageInfo(a0)
 move.l #JPEGGetImageSize,CookieGetImageSize(a0)
 move.l #JPEGDecodeImage,CookieDecodeImage(a0)
 bsr.s DisplayMessage
 tst.b MiNTFlag				; MiNT Present ???
 beq.s .DefaultStartUp
.MiNTStartUp:
 move.w #$48,ProtectionMode		; World-Readable Mode
 move.l d7,a0
 bsr Malloc				; Change Program Mode to World-Readable
 move.w #$10,ProtectionMode		; Incoming Mallocs are 'Private'

.DefaultStartUp:
 clr.w -(sp)
 move.l d7,-(sp)			; BasePage+TEXT+DATA+BSS
 move.w #$31,-(sp)
 trap #1				; PTermRes

.InvalidHardware:
 move.l #InvalidHardwareTxt,TOSStringPtr
 move.l #RsString3,RsTedinfo2
.Error:
 bsr.s DisplayMessage
 clr.w -(sp)
 trap #1				; PTerm

.CookieError:
 move.l #CookieErrorTxt,TOSStringPtr
 move.l #RsString4,RsTedinfo2
 bra.s .Error				; Display Error String + PTerm

.MemoryError:
 move.l 8(a1),(a1)			; Remove '_JPD' Cookie
 move.l $c(a1),4(a1)
 move.l #MemoryErrorTxt,TOSStringPtr
 move.l #RsString5,RsTedinfo2
 bra.s .Error				; Display Error String + PTerm

;  #] Start Up: 
;  #[ Display Message:

DisplayMessage:
 movem.l d0-d4/a0-a2,-(sp)
 clr.w Global
 bsr ApplInit
 tst.w Global
 beq .TOSMessage
 tst.w d0
 bmi .TOSMessage
.GEMMessage:
 bsr GrafHandle
 move.w IntOut+4(pc),d0
 lea JPEGDecoderBox(pc),a0
 bsr RelocateTree
 lea AddrIn(pc),a1
 move.l a0,(a1)
 bsr FormCenter
 movem.w IntOut+2(pc),d1-d4
 lea IntIn(pc),a0
 clr.w (a0)+
 movem.w d1-d4,(a0)
 movem.w d1-d4,8(a0)
 bsr FormDial
 lea IntIn(pc),a0
 move.w #1,(a0)
 bsr WindUpdate
 move.w #3,(a0)
 bsr WindUpdate
 lea JPEGDecoderBox(pc),a0
 lea AddrIn(pc),a1
 move.l a0,(a1)
 lea IntIn(pc),a0
 clr.w (a0)+
 move.w #1,(a0)+
 movem.w d1-d4,(a0)
 bsr ObjcDraw
 bsr Wait
 lea IntIn(pc),a0
 move.w #2,(a0)
 bsr WindUpdate
 clr.w (a0)
 bsr WindUpdate
 lea IntIn(pc),a0
 move.w #3,(a0)+
 movem.w d1-d4,(a0)
 movem.w d1-d4,8(a0)
 bsr FormDial
 bsr ApplExit
 bra.s .End

.TOSMessage:
 pea JPEGDecoderTxt(pc)
 move.w #9,-(sp)
 trap #1
 addq.w #6,sp
 move.l TOSStringPtr(pc),-(sp)
 move.w #9,-(sp)
 trap #1
 addq.w #6,sp
 bsr Wait
.End:
 movem.l (sp)+,d0-d4/a0-a2
 rts

;  #] Display Message: 
;  #[ Test Hardware:
;
; OUT:
; D0 = 0 / -1 (Invalid Hardware Configuration)
TestHardware:
 movem.l d1-d3/a0-a2,-(sp)
 move.w #$67,-(sp)
 trap #$e				; DSPGetWordSize
 addq.w #2,sp
 cmp.w #3,d0				; DSP5600x ???
 sne d3
 ext.w d3				; Error1
 pea .TestMCU(pc)			; Push Supervisor Routine
 move.w #$26,-(sp)
 trap #$e				; Supexec
 addq.w #6,sp
 move.w ReturnCode(pc),d0
 or.w d3,d0				; Error1 | Error2
 movem.l (sp)+,d1-d3/a0-a2
 rts

.TestMCU:
 moveq #-1,d1				; Init. Error2
 move.l #'_CPU',d2
 move.l $5a0.w,a0
.Loop:
 move.l (a0),d0
 addq.w #8,a0
 beq.s .End				; End of Cookie Jar ???
 cmp.l d0,d2				; '_CPU' Cookie ???
 bne.s .Loop
 cmp.l #20,-4(a0)			; MC68020 or Higher ???
 slt d1
 ext.w d1				; Set Error2
.End:
 move.w d1,ReturnCode			; Copy Error2
 rts

;  #] Test Hardware: 
;  #[ Install Cookie:
;
; OUT:
; D0 = 0 / -1 (Error)
; A0 = JPEG Decoder Cookie Address
InstallCookie:
 movem.l d1-d2/a1-a2,-(sp)
 pea .InstallCookie(pc)
 move.w #$26,-(sp)
 trap #$e
 addq.w #6,sp
 move.l ReturnValue(pc),a0
 move.w ReturnCode(pc),d0
 movem.l (sp)+,d1-d2/a1-a2
 rts

; OUT:
; D0 = 0 / -1 (Error)
; A0 = Decoder Cookie Address
;
; Assume:
; - Cookie Jar Present
; - Enough Cookies Allocated
.InstallCookie:
 move.l #'MiNT',d1
 move.l #'_JPD',d2			; '_JPD' is a reserved Atari Name
 move.l #'Free',d3
 move.l $5a0.w,a0
.CookieLoop:
 move.l (a0),d0
 beq.s .EndofCookie
 cmp.l d1,d0				; 'MiNT' Cookie ???
 bne.s .NotMiNT
.MiNT:
 st MiNTFlag				; Set MiNT Flag
 bra.s .NotJPEGDecoder
.NotMiNT:
 cmp.l d2,d0				; '_JPD' Cookie ???
 beq.s .Error				; Decoder already installed
.NotJPEGDecoder:
 cmp.l d3,d0				; 'Free' Cookie ???
 beq.s .End
 addq.w #8,a0
 bra.s .CookieLoop
.EndofCookie:
 clr.l 8(a0)				; Move End of Cookie
 move.l 4(a0),$c(a0)			; Move End of Cookie
.End:
 move.l d2,(a0)				; Write '_JPD' Cookie
 move.l a0,ReturnValue
 clr.w ReturnCode
 rts

.Error:
 move.w #-1,ReturnCode
 rts

;  #] Install Cookie: 
;  #[ Remove Cookie:

RemoveCookie:
 movem.l d0-d2/a0-a2,-(sp)
 pea .RemoveCookie(pc)
 move.w #$26,-(sp)
 trap #$e
 addq.w #6,sp
 movem.l (sp)+,d0-d2/a0-a2
 rts

.RemoveCookie:
 move.l #'_JPD',d1
 move.l $5a0.w,a0
.Loop:
 move.l (a0),d0
 addq.w #8,a0
 beq.s .EndCookie
 cmp.l d0,d1
 bne.s .Loop
 move.l #'Free',-8(a0)			; Change Cookie to Dummy Cookie
 move.l -4(a0),d0
 clr.l -4(a0)
 move.l d0,a0				; Free Cookie Structure
 bsr MFree
.EndCookie:
 rts

;  #] Remove Cookie: 
;  #[ JPEG Driver Routines:
;	 #[ JPEG Open Driver:
;
; IN:
; A0 = JPEG Structure Pointer
; OUT:
; D0 = 0 / Error
JPEGOpenDriver:
 movem.l a0/a6,-(sp)
 move.l a0,a6
 move.w JPEGProcessNumber(pc),d0
 bne.s .DriverOpened
 bsr InstallDSPDecoder
 bne.s .End
.DriverOpened:
 cmp.w #$20,d0
 bgt.s .DecoderBusy
 addq.w #1,JPEGProcessNumber
 lea JPEGProcessHandles(pc),a0
 moveq #$1f,d0
.Loop:
 tst.b (a0)+
 dbeq d0,.Loop
 st -(a0)
 sub.w #$20,d0
 neg.w d0
 move.w d0,UserHandle(a6)
 moveq #NOERROR,d0
.End:
 movem.l (sp)+,a0/a6
 rts

.DecoderBusy:
 moveq #DECODERBUSY,d0
 bra.s .End

;	 #] JPEG Open Driver: 
;	 #[ JPEG Close Driver:
;
; IN:
; A0 = JPEG Structure Pointer
; OUT:
; D0 = 0 / Error
JPEGCloseDriver:
 move.l a6,-(sp)
 move.l a0,a6
 tst.w JPEGProcessNumber
 beq.s .DriverNotOpened
.DSPWorking:
 tas DSPBusyFlag
 bne.s .DSPWorking
 move.w UserHandle(a6),d0
 sf (JPEGProcessHandles.l,d0.w)
 clr.w JPEGCurrentProcess
 subq.w #1,JPEGProcessNumber
 bne.s .NotLastProcess
 bsr DSPUnlock
.NotLastProcess:
 sf DSPBusyFlag
 moveq #NOERROR,d0
.End:
 move.l (sp)+,a6
 rts

.DriverNotOpened:
 moveq #DRIVERCLOSED,d0
 bra.s .End

;	 #] JPEG Close Driver: 
;	 #[ JPEG Get Structure Size:
;
; OUT:
; D0 = JPEG Decoder Structure Size (Bytes)
JPEGGetStructSize:
 moveq #0,d0
 move.w #JPEGDecoderStruct,d0
 rts

;	 #] JPEG Get Structure Size: 
;	 #[ JPEG Get Image Info:
;
; IN:
; A0 = JPEG Structure Pointer
;
; -> means 'Input Parameter'
; <- means 'Output Parameter'
;
;  ->	InPointer
; 	OutPointer
;  ->	InSize
; 	OutSize
;  <-	InComponents
; 	OutComponents
; 	OutPixelSize
; 	OutFlag
; 	XLoopCounter
; 	YLoopCounter
; 	CreateOutputPtr
; 	WriteOutputPtr
; 	CloseOutputPtr
; 	SigTermOutputPtr
; 	Comp1GammaPtr
; 	Comp2GammaPtr
; 	Comp3GammaPtr
; 	Comp4GammaPtr
; 	UserRoutinePtr
;	OutTmpPointer
;	MCUsCounter
;	OutTmpHeight
;	UserLong1
;	UserLong2
;	OutHandle
;	MFDBAddress
;  <-	MFDBPixelWidth
;  <-	MFDBPixelHeight
;	MFDBWordSize
;	MFDBFormatFlag
;	MFDBBitPlanes
;	MFDBReserved,3
;
; OUT:
; D0 = 0 / Error
JPEGGetImageInfo:
 movem.l d1-d7/a0/a5-a6,-(sp)
 move.l a0,a6
 move.l (a6),a5				; InPointer(a6) (Optimization)
 move.l InSize(a6),InCurSize(a6)
 bsr GetSOFn
 bne.s .End
 move.l a0,a5
 move.l InCurSize(a6),d1
 subq.l #5,d1
 bmi.s .ImageTruncated
 addq.w #3,a5
 move.w (a5)+,OutMFDB+MFDBPixelHeight(a6)
 beq.s .DNLMarker
 subq.l #2,d1
 bmi.s .ImageTruncated
 move.w (a5)+,OutMFDB+MFDBPixelWidth(a6)
 subq.l #1,d1
 bmi.s .ImageTruncated
 moveq #0,d0
 move.b (a5)+,d0
 move.w d0,InComponents(a6)
 moveq #NOERROR,d0
.End:
 movem.l (sp)+,d1-d7/a0/a5-a6
 rts

.ImageTruncated:
 move.l d1,InCurSize(a6)
 moveq #IMAGETRUNCATED,d0
 bra.s .End

.DNLMarker:
 moveq #DNLMARKER,d0
 rts

;	 #] JPEG Get Image Info: 
;	 #[ JPEG Get Image Size:
;
; IN:
; A0 = JPEG Structure Pointer
;
; -> means 'Input Parameter'
; <- means 'Output Parameter'
;
;	InPointer
;	OutPointer
;	InSize
;  <-	OutSize
;	InComponents
;  ->	OutComponents
;  ->	OutPixelSize
;	OutFlag
;	XLoopCounter
;	YLoopCounter
;	CreateOutputPtr
;	WriteOutputPtr
;	CloseOutputPtr
;	SigTermOutputPtr
;	Comp1GammaPtr
;	Comp2GammaPtr
;	Comp3GammaPtr
;	Comp4GammaPtr
;	UserRoutinePtr
;	OutTmpPointer
;	MCUsCounter
;	OutTmpHeight
;	UserLong1
;	UserLong2
;	OutHandle
;	MFDBAddress
;	MFDBPixelWidth
;	MFDBPixelHeight
;  <-	MFDBWordSize
;	MFDBFormatFlag
;	MFDBBitPlanes
;	MFDBReserved,3
;
; OUT:
; D0 = 0 / Error
JPEGGetImageSize:
 movem.l d1-d7/a0/a5-a6,-(sp)
 move.l a0,a6
 move.l (a6),a5				; InPointer(a6) (Optimization)
 move.l InSize(a6),InCurSize(a6)
 bsr GetSOFn
 bne .End
 move.l a0,a5
 move.l InCurSize(a6),d4
 subq.l #8,d4
 bmi .ImageTruncated
 addq.w #8,a5
 moveq #0,d1
 moveq #0,d2
 moveq #0,d6
 moveq #0,d7
 move.w InComponents(a6),d0
 subq.w #1,d0
.CompLoop:
 subq.l #1,d4
 bmi.s .ImageTruncated
 addq.w #1,a5
 subq.l #1,d4
 bmi.s .ImageTruncated
 move.b (a5)+,d1
 move.b d1,d2
 and.b #$f,d2
 lsr.b #4,d1
 cmp.b d1,d6
 bge.s .XSmaller
 move.b d1,d6
.XSmaller:
 cmp.b d2,d7
 bge.s .YSmaller
 move.b d2,d7
.YSmaller:
 subq.l #1,d4
 bmi.s .ImageTruncated
 addq.w #1,a5
 dbf d0,.CompLoop
 move.w OutMFDB+MFDBPixelWidth(a6),d0
 move.w OutMFDB+MFDBPixelHeight(a6),d1
 lsl.w #3,d6
 lsl.w #3,d7
 divu d6,d0
 divu d7,d1
 swap d0
 swap d1
 tst.w d0
 sne d2
 tst.w d1
 sne d3
 ext.w d2
 ext.w d3
 swap d0
 swap d1
 sub.w d2,d0
 sub.w d3,d1
 mulu d6,d0
 mulu d7,d1
 add.w #$f,d0
 and.w #$fff0,d0
 mulu OutPixelSize(a6),d0
 move.w d0,OutMFDB+MFDBWordSize(a6)
 lsr OutMFDB+MFDBWordSize(a6)
 mulu d1,d0
 move.l d0,OutSize(a6)
 moveq #NOERROR,d0
.End:
 movem.l (sp)+,d1-d7/a0/a5-a6
 rts

.ImageTruncated:
 moveq #IMAGETRUNCATED,d0
 bra.s .End

;	 #] JPEG Get Image Size: 
;	 #[ JPEG Decode Image:
;
; IN:
; A0 = JPEG Structure Pointer
;
; -> means 'Input Parameter'
; <- means 'Output Parameter'
; () means 'Optional Parameter'
;
;	InPointer
;	OutPointer
;	InSize
;	OutSize
;	InComponents
;	OutComponents
;	OutPixelSize
;  ->	OutFlag
;	XLoopCounter
;	YLoopCounter
; (->)	CreateOutputPtr
; (->)	WriteOutputPtr
; (->)	CloseOutputPtr
; (->)	SigTermOutputPtr
; (->)	Comp1GammaPtr
; (->)	Comp2GammaPtr
; (->)	Comp3GammaPtr
; (->)	Comp4GammaPtr
; (->)	UserRoutinePtr
;	OutTmpPointer
;	MCUsCounter
;	OutTmpHeight
;	UserLong1
;	UserLong2
;	OutHandle
;  <-	MFDBAddress
;  <-	MFDBPixelWidth
;  <-	MFDBPixelHeight
;  <-	MFDBWordSize
;  <-	MFDBFormatFlag
;  <-	MFDBBitPlanes
;  <-	MFDBReserved,3
;
; OUT:
; D0 = 0 / Error
JPEGDecodeImage:
 movem.l d1/a0/a5-a6,-(sp)
 move.l a0,a6				; JPEG Structure Pointer
 move.l (a6),a5				; InPointer(a6) (Optimization)
 move.l InSize(a6),InCurSize(a6)	; Init Current Size
 subq.l #2,InCurSize(a6)		; 2 Bytes Availables ???
 bmi.s .ImageTruncated
 move.w (a5)+,d0			; Read Two Bytes
 cmp.w #$ffd8,d0			; Test SOI Marker (Start of JFIF File)
 bne.s .UnknownFormat			; Not a JFIF File
 sf DNLInternalFlag(a6)			; Default Case is 'No DNL'
 sf DRIInternalFlag(a6)			; a SOI Marker Disables the Restart Intervals
.Loop:
 subq.l #1,InCurSize(a6)		; 1 Byte Available ???
 bmi.s .ImageTruncated
 move.b (a5)+,d0			; Read 1 Byte
 addq.b #1,d0				; Test $FF (Marker)
 bne.s .MissingMarker
 bsr.s MarkersSwitch			; Analyse Marker
 beq.s .Loop				; Test Error
 sub.w #ENDOFIMAGE,d0			; Test if EOI Marker
 beq.s .TestImageSize			; End of Image
 add.w #ENDOFIMAGE,d0			; Restore Return Value
 bsr SigTermOutput			; Signal Error to the Output Routines
 bra.s .FreeAll
.TestImageSize:
 tst.l InCurSize(a6)			; Test if Extra Bytes after EOI Marker
 sne d0
 ext.l d0
 and.l #EXTRABYTES,d0
.FreeAll:
 move.l d0,-(sp)			; Save Return Code
 move.l MCUInBuffer(a6),a0
 bsr.s .Free				; Free DSP Input Buffer
 move.l MCUOutBuffer(a6),a0
 bsr.s .Free				; Free DSP Output Buffer
 move.l HuffDCPointers(a6),a0
 bsr.s .Free				; Free Huffman DC Tree 0
 move.l HuffDCPointers+4(a6),a0
 bsr.s .Free				; Free Huffman DC Tree 1
 move.l HuffACPointers(a6),a0
 bsr.s .Free				; Free Huffman AC Tree 0
 move.l HuffACPointers+4(a6),a0
 bsr.s .Free				; Free Huffman AC Tree 1
 tst.w OutFlag(a6)
 beq.s .RAMOutput
.DiskOutput:
 move.l OutTmpPointer(a6),a0		; Free Temporary Disk Buffer
 bsr.s .Free
.RAMOutput:
 move.l (sp)+,d0			; Restore Return Code
.End:
 tst.l d0				; Set CCR According to Return Code
 movem.l (sp)+,d1/a0/a5-a6
 rts

.ImageTruncated:
 moveq #IMAGETRUNCATED,d0
 bra.s .End

.UnknownFormat:
 moveq #UNKNOWNFORMAT,d0
 bra.s .End

.MissingMarker:
 moveq #MISSINGMARKER,d0
 bra.s .FreeAll

.Free:
 move.l a0,d0				; Test if Buffer Allocated
 beq.s .NoFree
 bsr MFree				; Free Buffer
.NoFree:
 rts

;	 #] JPEG Decode Image: 
;  #] JPEG Driver Routines: 
;  #[ Markers Switch:

MarkersSwitch:
 moveq #0,d0
 subq.l #1,InCurSize(a6)		; 1 Byte Available ???
 bmi.s .ImageTruncated
 move.b (a5)+,d0			; Read 1 Byte
 eor.b #$80,d0				; Test Byte Sign
 bmi RESRoutine				; ($00->$7f means Reserved Marker)
 move.w .MarkersTable(pc,d0.w*2),d0
 jmp .MarkersTable(pc,d0.w)
.ImageTruncated:
 moveq #IMAGETRUNCATED,d0
 rts

.MarkersTable:
 dc.w RESRoutine-.MarkersTable		; $80	Reserved
 dc.w RESRoutine-.MarkersTable		; $81	Reserved
 dc.w RESRoutine-.MarkersTable		; $82	Reserved
 dc.w RESRoutine-.MarkersTable		; $83	Reserved
 dc.w RESRoutine-.MarkersTable		; $84	Reserved
 dc.w RESRoutine-.MarkersTable		; $85	Reserved
 dc.w RESRoutine-.MarkersTable		; $86	Reserved
 dc.w RESRoutine-.MarkersTable		; $87	Reserved
 dc.w RESRoutine-.MarkersTable		; $88	Reserved
 dc.w RESRoutine-.MarkersTable		; $89	Reserved
 dc.w RESRoutine-.MarkersTable		; $8a	Reserved
 dc.w RESRoutine-.MarkersTable		; $8b	Reserved
 dc.w RESRoutine-.MarkersTable		; $8c	Reserved
 dc.w RESRoutine-.MarkersTable		; $8d	Reserved
 dc.w RESRoutine-.MarkersTable		; $8e	Reserved
 dc.w RESRoutine-.MarkersTable		; $8f	Reserved
 dc.w RESRoutine-.MarkersTable		; $90	Reserved
 dc.w RESRoutine-.MarkersTable		; $91	Reserved
 dc.w RESRoutine-.MarkersTable		; $92	Reserved
 dc.w RESRoutine-.MarkersTable		; $93	Reserved
 dc.w RESRoutine-.MarkersTable		; $94	Reserved
 dc.w RESRoutine-.MarkersTable		; $95	Reserved
 dc.w RESRoutine-.MarkersTable		; $96	Reserved
 dc.w RESRoutine-.MarkersTable		; $97	Reserved
 dc.w RESRoutine-.MarkersTable		; $98	Reserved
 dc.w RESRoutine-.MarkersTable		; $99	Reserved
 dc.w RESRoutine-.MarkersTable		; $9a	Reserved
 dc.w RESRoutine-.MarkersTable		; $9b	Reserved
 dc.w RESRoutine-.MarkersTable		; $9c	Reserved
 dc.w RESRoutine-.MarkersTable		; $9d	Reserved
 dc.w RESRoutine-.MarkersTable		; $9e	Reserved
 dc.w RESRoutine-.MarkersTable		; $9f	Reserved
 dc.w RESRoutine-.MarkersTable		; $a0	Reserved
 dc.w RESRoutine-.MarkersTable		; $a1	Reserved
 dc.w RESRoutine-.MarkersTable		; $a2	Reserved
 dc.w RESRoutine-.MarkersTable		; $a3	Reserved
 dc.w RESRoutine-.MarkersTable		; $a4	Reserved
 dc.w RESRoutine-.MarkersTable		; $a5	Reserved
 dc.w RESRoutine-.MarkersTable		; $a6	Reserved
 dc.w RESRoutine-.MarkersTable		; $a7	Reserved
 dc.w RESRoutine-.MarkersTable		; $a8	Reserved
 dc.w RESRoutine-.MarkersTable		; $a9	Reserved
 dc.w RESRoutine-.MarkersTable		; $aa	Reserved
 dc.w RESRoutine-.MarkersTable		; $ab	Reserved
 dc.w RESRoutine-.MarkersTable		; $ac	Reserved
 dc.w RESRoutine-.MarkersTable		; $ad	Reserved
 dc.w RESRoutine-.MarkersTable		; $ae	Reserved
 dc.w RESRoutine-.MarkersTable		; $af	Reserved
 dc.w RESRoutine-.MarkersTable		; $b0	Reserved
 dc.w RESRoutine-.MarkersTable		; $b1	Reserved
 dc.w RESRoutine-.MarkersTable		; $b2	Reserved
 dc.w RESRoutine-.MarkersTable		; $b3	Reserved
 dc.w RESRoutine-.MarkersTable		; $b4	Reserved
 dc.w RESRoutine-.MarkersTable		; $b5	Reserved
 dc.w RESRoutine-.MarkersTable		; $b6	Reserved
 dc.w RESRoutine-.MarkersTable		; $b7	Reserved
 dc.w RESRoutine-.MarkersTable		; $b8	Reserved
 dc.w RESRoutine-.MarkersTable		; $b9	Reserved
 dc.w RESRoutine-.MarkersTable		; $ba	Reserved
 dc.w RESRoutine-.MarkersTable		; $bb	Reserved
 dc.w RESRoutine-.MarkersTable		; $bc	Reserved
 dc.w RESRoutine-.MarkersTable		; $bd	Reserved
 dc.w RESRoutine-.MarkersTable		; $be	Reserved
 dc.w RESRoutine-.MarkersTable		; $bf	Reserved
 dc.w SOF0Routine-.MarkersTable		; $c0	Baseline DCT
 dc.w SOF1Routine-.MarkersTable		; $c1	Extended sequential DCT
 dc.w SOF2Routine-.MarkersTable		; $c2	Progressive DCT
 dc.w SOF3Routine-.MarkersTable		; $c3	Spatial (sequential) lossless
 dc.w DHTRoutine-.MarkersTable		; $c4	Define Huffman table(s)
 dc.w SOF5Routine-.MarkersTable		; $c5	Differential sequential DCT
 dc.w SOF6Routine-.MarkersTable		; $c6	Differential progressive DCT
 dc.w SOF7Routine-.MarkersTable		; $c7	Differential spatial
 dc.w JPGRoutine-.MarkersTable		; $c8	Reserved for JPEG extensions
 dc.w SOF9Routine-.MarkersTable		; $c9	Extended sequential DCT
 dc.w SOF10Routine-.MarkersTable	; $ca	Progressive DCT
 dc.w SOF11Routine-.MarkersTable	; $cb	Spatial (sequential) lossless
 dc.w DACRoutine-.MarkersTable		; $cc	Define arithmetic coding conditioning(s)
 dc.w SOF13Routine-.MarkersTable	; $cd	Differential sequential DCT
 dc.w SOF14Routine-.MarkersTable	; $ce	Differential progressive DCT
 dc.w SOF15Routine-.MarkersTable	; $cf	Differential spatial
 dc.w RST0Routine-.MarkersTable		; $d0	Restart with modulo 8 count 0
 dc.w RST1Routine-.MarkersTable		; $d1	Restart with modulo 8 count 1
 dc.w RST2Routine-.MarkersTable		; $d2	Restart with modulo 8 count 2
 dc.w RST3Routine-.MarkersTable		; $d3	Restart with modulo 8 count 3
 dc.w RST4Routine-.MarkersTable		; $d4	Restart with modulo 8 count 4
 dc.w RST5Routine-.MarkersTable		; $d5	Restart with modulo 8 count 5
 dc.w RST6Routine-.MarkersTable		; $d6	Restart with modulo 8 count 6
 dc.w RST7Routine-.MarkersTable		; $d7	Restart with modulo 8 count 7
 dc.w SOIRoutine-.MarkersTable		; $d8	Start of image
 dc.w EOIRoutine-.MarkersTable		; $d9	End of image
 dc.w SOSRoutine-.MarkersTable		; $da	Start of scan
 dc.w DQTRoutine-.MarkersTable		; $db	Define quantization table(s)
 dc.w DNLRoutine-.MarkersTable		; $dc	Define number of lines
 dc.w DRIRoutine-.MarkersTable		; $dd	Define restart interval
 dc.w DHPRoutine-.MarkersTable		; $de	Define hierarchical progression
 dc.w EXPRoutine-.MarkersTable		; $df	Expand reference component(s)
 dc.w APPnRoutine-.MarkersTable		; $e0	Reserved for application segments
 dc.w APPnRoutine-.MarkersTable		; $e1	Reserved for application segments
 dc.w APPnRoutine-.MarkersTable		; $e2	Reserved for application segments
 dc.w APPnRoutine-.MarkersTable		; $e3	Reserved for application segments
 dc.w APPnRoutine-.MarkersTable		; $e4	Reserved for application segments
 dc.w APPnRoutine-.MarkersTable		; $e5	Reserved for application segments
 dc.w APPnRoutine-.MarkersTable		; $e6	Reserved for application segments
 dc.w APPnRoutine-.MarkersTable		; $e7	Reserved for application segments
 dc.w APPnRoutine-.MarkersTable		; $e8	Reserved for application segments
 dc.w APPnRoutine-.MarkersTable		; $e9	Reserved for application segments
 dc.w APPnRoutine-.MarkersTable		; $ea	Reserved for application segments
 dc.w APPnRoutine-.MarkersTable		; $eb	Reserved for application segments
 dc.w APPnRoutine-.MarkersTable		; $ec	Reserved for application segments
 dc.w APPnRoutine-.MarkersTable		; $ed	Reserved for application segments
 dc.w APPnRoutine-.MarkersTable		; $ee	Reserved for application segments
 dc.w APPnRoutine-.MarkersTable		; $ef	Reserved for application segments
 dc.w JPGnRoutine-.MarkersTable		; $f0	Reserved for JPEG extensions
 dc.w JPGnRoutine-.MarkersTable		; $f1	Reserved for JPEG extensions
 dc.w JPGnRoutine-.MarkersTable		; $f2	Reserved for JPEG extensions
 dc.w JPGnRoutine-.MarkersTable		; $f3	Reserved for JPEG extensions
 dc.w JPGnRoutine-.MarkersTable		; $f4	Reserved for JPEG extensions
 dc.w JPGnRoutine-.MarkersTable		; $f5	Reserved for JPEG extensions
 dc.w JPGnRoutine-.MarkersTable		; $f6	Reserved for JPEG extensions
 dc.w JPGnRoutine-.MarkersTable		; $f7	Reserved for JPEG extensions
 dc.w JPGnRoutine-.MarkersTable		; $f8	Reserved for JPEG extensions
 dc.w JPGnRoutine-.MarkersTable		; $f9	Reserved for JPEG extensions
 dc.w JPGnRoutine-.MarkersTable		; $fa	Reserved for JPEG extensions
 dc.w JPGnRoutine-.MarkersTable		; $fb	Reserved for JPEG extensions
 dc.w JPGnRoutine-.MarkersTable		; $fc	Reserved for JPEG extensions
 dc.w JPGnRoutine-.MarkersTable		; $fd	Reserved for JPEG extensions
 dc.w COMRoutine-.MarkersTable		; $fe	Comment
 dc.w MarkersSwitch-.MarkersTable	; $ff	Fill Byte

;  #] Markers Switch: 
;  #[ Markers Routines:
;	 #[ RES Routine:

RESRoutine:
 moveq #INVALIDMARKER,d0		; Reserved Marker, Error
 rts

;	 #] RES Routine: 
;	 #[ SOFn Routines:
;		#[ SOF0 Routine:

SOF0Routine:
 movem.l d1-d6/a0-a1,-(sp)
 move.l InCurSize(a6),d6
 subq.l #2,d6				; 2 Bytes Availables ???
 bmi .ImageTruncated
 move.w (a5)+,d5			; Read 2 Bytes (Frame Header Length)
 subq.l #1,d6				; 1 Byte Available ???
 bmi .ImageTruncated
 move.b (a5)+,d0			; Read 1 Byte (Sample Precision)
 cmp.b #8,d0
 bne .Error
 subq.l #2,d6				; 2 Bytes Availables ???
 bmi .ImageTruncated
 move.w (a5)+,OutMFDB+MFDBPixelHeight(a6)
 beq .DNLMarker
 move.l d6,InCurSize(a6)
 subq.l #2,d6				; 2 Bytes Availables ???
 bmi .ImageTruncated
 move.w (a5)+,OutMFDB+MFDBPixelWidth(a6)
 beq .Error
 moveq #0,d4
 subq.l #1,d6				; 1 Bytes Available ???
 bmi.s .ImageTruncated
 move.b (a5)+,d4			; Read 1 Byte (Number of Image Components)
 beq.s .Error
 cmp.w #4,d4				; Maximum = 4 Components
 bhi.s .Error
 move.w d4,InComponents(a6)
 lea ComponentsInternal(a6),a0
 lea ComponentsIDs(a6),a1
 not.l (a1)
 not.l 4(a1)
 not.w 8(a1)
 moveq #0,d2
 move.w d4,d3
 mulu #3,d3
 addq.w #8,d3				; Calculate Frame Length
 subq.w #1,d4				; Components - 1 (For DBcc)
 bmi.s .Error
.ComponentLoop:
 subq.l #1,d6
 bmi.s .ImageTruncated
 move.b (a5)+,d2
 move.w d2,(a1)+
 tas 0(a0,d2.w*4)			; Test if Component Free
 bne.s .Error
 subq.l #1,d6
 bmi.s .ImageTruncated
 move.b (a5)+,d0
 move.b d0,d1
 and.b #$f,d1
 eor.b d1,d0
 lsr.b #4,d0
 move.b d0,1(a0,d2.w*4)			; X Sampling Factor
 move.b d1,2(a0,d2.w*4)			; Y Sampling Factor
 subq.l #1,d6
 bmi.s .ImageTruncated
 move.b (a5)+,3(a0,d2.w*4)		; Quantization Table Selector
 dbf d4,.ComponentLoop
 cmp.w d5,d3				; Test if Valid Frame Length
 bne.s .Error
 move.w #SOF0,JPEGMode(a6)		; Set JPEG Decompression Mode (Baseline DCT)
 move.l d6,InCurSize(a6)
 moveq #NOERROR,d0
.End:
 movem.l (sp)+,d1-d6/a0-a1
 rts

.ImageTruncated:
 moveq #IMAGETRUNCATED,d0
 bra.s .End

.Error:
 moveq #BADSOFnMARKER,d0
 bra.s .End

.DNLMarker:
 moveq #DNLMARKER,d0
 bra.s .End

;		#] SOF0 Routine: 
;		#[ SOF1 Routine:

SOF1Routine:
 moveq #SOF1MARKER,d0			; Error, Mode not Handled by the Decoder
 rts

;		#] SOF1 Routine: 
;		#[ SOF2 Routine:

SOF2Routine:
 moveq #SOF2MARKER,d0			; Error, Mode not Handled by the Decoder
 rts

;		#] SOF2 Routine: 
;		#[ SOF3 Routine:

SOF3Routine:
 moveq #SOF3MARKER,d0			; Error, Mode not Handled by the Decoder
 rts

;		#] SOF3 Routine: 
;		#[ SOF5 Routine:

SOF5Routine:
 moveq #SOF5MARKER,d0			; Error, Mode not Handled by the Decoder
 rts

;		#] SOF5 Routine: 
;		#[ SOF6 Routine:

SOF6Routine:
 moveq #SOF6MARKER,d0			; Error, Mode not Handled by the Decoder
 rts

;		#] SOF6 Routine: 
;		#[ SOF7 Routine:

SOF7Routine:
 moveq #SOF7MARKER,d0			; Error, Mode not Handled by the Decoder
 rts

;		#] SOF7 Routine: 
;		#[ SOF9 Routine:

SOF9Routine:
 moveq #SOF9MARKER,d0			; Error, Mode not Handled by the Decoder
 rts

;		#] SOF9 Routine: 
;		#[ SOF10 Routine:

SOF10Routine:
 moveq #SOF10MARKER,d0			; Error, Mode not Handled by the Decoder
 rts

;		#] SOF10 Routine: 
;		#[ SOF11 Routine:

SOF11Routine:
 moveq #SOF11MARKER,d0			; Error, Mode not Handled by the Decoder
 rts

;		#] SOF11 Routine: 
;		#[ SOF13 Routine:

SOF13Routine:
 moveq #SOF13MARKER,d0			; Error, Mode not Handled by the Decoder
 rts

;		#] SOF13 Routine: 
;		#[ SOF14 Routine:

SOF14Routine:
 moveq #SOF14MARKER,d0			; Error, Mode not Handled by the Decoder
 rts

;		#] SOF14 Routine: 
;		#[ SOF15 Routine:

SOF15Routine:
 moveq #SOF15MARKER,d0			; Error, Mode not Handled by the Decoder
 rts

;		#] SOF15 Routine: 
;	 #] SOFn Routines: 
;	 #[ RSTm Routines:
;		#[ RST0 Routine:

RST0Routine:
 moveq #RSTmMARKER,d0			; Error, Unexpected RST0 Marker
 rts

;		#] RST0 Routine: 
;		#[ RST1 Routine:

RST1Routine:
 moveq #RSTmMARKER,d0			; Error, Unexpected RST1 Marker
 rts

;		#] RST1 Routine: 
;		#[ RST2 Routine:

RST2Routine:
 moveq #RSTmMARKER,d0			; Error, Unexpected RST2 Marker
 rts

;		#] RST2 Routine: 
;		#[ RST3 Routine:

RST3Routine:
 moveq #RSTmMARKER,d0			; Error, Unexpected RST3 Marker
 rts

;		#] RST3 Routine: 
;		#[ RST4 Routine:

RST4Routine:
 moveq #RSTmMARKER,d0			; Error, Unexpected RST4 Marker
 rts

;		#] RST4 Routine: 
;		#[ RST5 Routine:

RST5Routine:
 moveq #RSTmMARKER,d0			; Error, Unexpected RST5 Marker
 rts

;		#] RST5 Routine: 
;		#[ RST6 Routine:

RST6Routine:
 moveq #RSTmMARKER,d0			; Error, Unexpected RST6 Marker
 rts

;		#] RST6 Routine: 
;		#[ RST7 Routine:

RST7Routine:
 moveq #RSTmMARKER,d0			; Error, Unexpected RST7 Marker
 rts

;		#] RST7 Routine: 
;	 #] RSTm Routines: 
;	 #[ APPn Routine:

APPnRoutine:
 subq.l #2,InCurSize(a6)
 bmi.s .ImageTruncated
 moveq #0,d0
 move.w (a5)+,d0			; Marker Size
 subq.w #2,d0
 sub.l d0,InCurSize(a6)
 bmi.s .ImageTruncated
 add.l d0,a5				; Skip Marker
 moveq #NOERROR,d0
 rts

.ImageTruncated:
 moveq #IMAGETRUNCATED,d0
 rts

;	 #] APPn Routine: 
;	 #[ JPGn Routine:

JPGnRoutine:
 subq.l #2,InCurSize(a6)
 bmi.s .ImageTruncated
 moveq #0,d0
 move.w (a5)+,d0			; Marker Size
 subq.w #2,d0
 sub.l d0,InCurSize(a6)
 bmi.s .ImageTruncated
 add.l d0,a5				; Skip Marker
 moveq #NOERROR,d0
 rts

.ImageTruncated:
 moveq #IMAGETRUNCATED,d0
 rts

;	 #] JPGn Routine: 
;	 #[ DHT Routine:

DHTRoutine:
 movem.l d1-d4/a0-a3,-(sp)
 move.l a5,a3
 move.l InCurSize(a6),d4
 subq.l #2,d4
 bmi.s .ImageTruncated
 move.w (a5)+,d0			; Marker Size
 add.w d0,a3				; A3 = End of Marker Address
.TableLoop:
 moveq #0,d0
 subq.l #1,d4
 bmi.s .ImageTruncated
 move.b (a5)+,d0
 move.b d0,d1
 and.w #$f,d0				; Huffman Table Identifier
 cmp.w #1,d0				; Test If Huffman Table 0, 1 or Higher
 bhi.s .InvalidDHT
 eor.w d0,d1				; Huffman Table Class
 btst #4,d1				; 0 (DC) or 8 (AC)
 bne.s .ACTable
.DCTable:
 st (HuffDCFlags.w,a6,d0.w)
 move.l a5,a0
 move.l d4,InCurSize(a6)
 bsr GenHuffmanDCTree			; Generate DC Tree
 bne.s .End
 move.l InCurSize(a6),d4
 cmp.l a3,a5				; Test Marker Size
 blt.s .TableLoop			; More Huffman Tables ???
 bne.s .InvalidDHT			; Bad Marker Size ???
 move.l d4,InCurSize(a6)
 moveq #NOERROR,d0
.End:
 movem.l (sp)+,d1-d4/a0-a3
 rts

.ACTable:
 st (HuffACFlags.w,a6,d0.w)
 move.l a5,a0
 move.l d4,InCurSize(a6)
 bsr GenHuffmanACTree			; Generate AC Tree
 bne.s .End
 move.l InCurSize(a6),d4
 cmp.l a3,a5				; Test Marker Size
 blt.s .TableLoop			; More Huffman Tables ???
 bne.s .InvalidDHT			; Bad Marker Size ???
 move.l d4,InCurSize(a6)
 moveq #NOERROR,d0
 bra.s .End

.ImageTruncated:
 moveq #IMAGETRUNCATED,d0
 bra.s .End

.InvalidDHT:
 moveq #BADDHTMARKER,d0			; Invalid DHT Size
 bra.s .End

;	 #] DHT Routine: 
;	 #[ JPG Routine:

JPGRoutine:
 subq.l #2,InCurSize(a6)
 bmi.s .ImageTruncated
 moveq #0,d0
 move.w (a5)+,d0			; Marker Size
 subq.w #2,d0
 sub.l d0,InCurSize(a6)
 bmi.s .ImageTruncated
 add.l d0,a5				; SKip Marker
 moveq #NOERROR,d0
 rts

.ImageTruncated:
 moveq #IMAGETRUNCATED,d0
 rts

;	 #] JPG Routine: 
;	 #[ DAC Routine:

DACRoutine:
 moveq #DACMARKER,d0			; Error, Mode not Handled by the Decoder
 rts

;	 #] DAC Routine: 
;	 #[ SOI Routine:

SOIRoutine:
 moveq #INVALIDMARKER,d0		; Error, Unexpected SOI Marker
 rts

;	 #] SOI Routine: 
;	 #[ EOI Routine:

EOIRoutine:
 moveq #ENDOFIMAGE,d0			; End, Exit Decoder (Internal Message)
 rts

;	 #] EOI Routine: 
;	 #[ SOS Routine:

SOSRoutine:
 movem.l d1-d6/a0-a1,-(sp)
 cmp.w #SOF0,JPEGMode(a6)		; Test Compression Type
 bne .BadFormat				; This SOS Routine Only Handles 'Baseline DCT' Decoding
 move.l InCurSize(a6),d6
 subq.l #2,d6
 bmi .ImageTruncated
 move.w (a5)+,d5			; Ls (Scan Header Length)
 moveq #0,d3
 moveq #0,d4				; Init 'DUsPerMCU' Register
 subq.l #1,d6
 bmi .ImageTruncated
 move.b (a5)+,d3			; Ns (Number of Components in Scan)
 cmp.w InComponents(a6),d3		; Scans Contains All Components ???
 bne .BadFormat				; Decoder only handles interleaved scans
 subq.w #1,d3				; -1 (DBcc)
 lea ComponentsInternal(a6),a0		; Component IDs Table
 lea CompStruct(a6),a1			; Huffman Components Structure
 move.w d3,d1
 add.w d1,d1
 addq.w #8,d1
 cmp.w d5,d1				; Test if Ls (Scan Header Length) Valid
 bne .BadFormat
.ComponentLoop:
 moveq #0,d0
 subq.l #1,d6
 bmi .ImageTruncated
 move.b (a5)+,d0			; Get Component ID
 tst.b 0(a0,d0.w*4)			; Test if Valid Component
 beq .BadFormat
 moveq #0,d1
 moveq #0,d2
 move.b 1(a0,d0.w*4),d1			; Get X Sampling
 move.b 2(a0,d0.w*4),d2			; Get Y Sampling
 bsr GenExpandValue			; Test if Sampling Allowed
 bne .End
 mulu d2,d1				; Component's Data Units in MCU
 add.w d1,d4				; Add to Number Of Data Units In MCU
 subq.w #1,d1
 move.w d1,(a1)				; BlocksPerMCU(a1) (Optimization)
 moveq #0,d0
 subq.l #1,d6
 bmi .ImageTruncated
 move.b (a5)+,d0
 move.w d0,d1
 lsr.w #4,d0				; DC Entropy Selector
 and.w #$f,d1				; AC Entropy Selector
 tst.b (HuffDCFlags.w,a6,d0.w)		; DC Tree Calculated ???
 beq .BadFormat
 tst.b (HuffACFlags.w,a6,d1.w)		; AC Tree Calculated ???
 beq .BadFormat
 move.l HuffDCTrees(a6,d0.w*4),HuffDCTreePointer(a1)
 move.l HuffACTrees(a6,d1.w*4),HuffACTreePointer(a1)
 lea JPEGCompStruct(a1),a1
 dbf d3,.ComponentLoop			; Loop on all Components
 move.w d3,(a1)				; BlocksPerMCU(a1): End Of Huffman Structure
 move.w d4,DUsPerMCU(a6)
 bsr CalcMaxSampling			; Calculate Maximum X and Y Sampling
 subq.l #2,d6
 bmi .ImageTruncated
 move.w (a5)+,d0			; Ss + Se
 cmp.w #$3f,d0
 bne .BadFormat
 subq.l #1,d6
 bmi .ImageTruncated
 move.b (a5)+,d0			; Ah + Al
 bne .BadFormat
 moveq #0,d0
 move.w OutMFDB+MFDBPixelWidth(a6),d0
 move.w MaxXSampling(a6),d1
 lsl.w #3,d1
 divu d1,d0
 move.w d0,d1
 swap d0
 tst.w d0
 beq.s .GoodX
 addq.w #1,d1
.GoodX:
 move.w d1,XLoopCounter(a6)
 moveq #0,d0
 move.w OutMFDB+MFDBPixelHeight(a6),d0
 move.w MaxYSampling(a6),d1
 lsl.w #3,d1
 divu d1,d0
 move.w d0,d1
 swap d0
 tst.w d0
 beq.s .GoodY
 addq.w #1,d1
.GoodY:
 move.w d1,YLoopCounter(a6)
 moveq #0,d0
 move.w DUsPerMCU(a6),d0
 lsl.l #7,d0
 addq.l #4,d0
 move.l d0,d1
 bsr Malloc
 bne .End
 move.l a0,MCUInBuffer(a6)
 move.l a0,MCUEndInBuffer(a6)
 add.l d1,MCUEndInBuffer(a6)
 move.w MaxXSampling(a6),d0
 mulu MaxYSampling(a6),d0
 mulu XLoopCounter(a6),d0
 mulu InComponents(a6),d0
 lsl.l #6,d0
 bsr Malloc
 bne.s .End
 move.l a0,MCUOutBuffer(a6)
 move.w XLoopCounter(a6),d0
 mulu YLoopCounter(a6),d0
 move.w d0,MCUsCounter(a6)
 bsr CalculatePixelFormat
 bne.s .End
 bsr InitHuffmanDecoder
 bsr CreateMFDB
 bsr InitMCUInterlacing
 bne.s .End
 bsr CreateDSPDecoderStruct
 bsr SendDSPDecoderStruct
 bsr SendDSPGammaTables
 bsr CreateOutput
 bne.s .End
 move.l d6,InCurSize(a6)
 bsr DecodeImage
 bne.s .End
 move.l InCurSize(a6),d6
 bsr CloseOutput
 bne.s .End
 move.w HuffmanCurBit(a6),d0		; Resync. JPEG Datas Pointer
 moveq #-1,d1
 cmp.w #$f,d0
 blt.s .NotFullWord
 move.b -(a5),d0
 addq.l #1,d6
 cmp.b -1(a5),d1
 bne.s .NotFullWord
 subq.w #1,a5
 addq.l #1,d6
.NotFullWord:
 cmp.w #8,d0
 blt.s .EndEven
 move.b -(a5),d0
 addq.l #1,d6
 cmp.b -1(a5),d1
 bne.s .EndEven
 subq.w #1,a5
 addq.l #1,d6
.EndEven:
 move.l d6,InCurSize(a6)
 moveq #NOERROR,d0
.End:
 movem.l (sp)+,d1-d6/a0-a1
 rts

.ImageTruncated:
 moveq #IMAGETRUNCATED,d0
 bra.s .End

.BadFormat:
 moveq #BADSOSMARKER,d0
 bra.s .End

;	 #] SOS Routine: 
;	 #[ DQT Routine:

DQTRoutine:
 movem.l d1-d4/a0-a1,-(sp)
 move.l InCurSize(a6),d4
 moveq #65,d1				; Quantization Table Size
 subq.l #2,d4
 bmi.s .ImageTruncated
 move.w (a5)+,d0			; Get Marker Size
 subq.w #2,d0
 moveq #0,d3				; One Table Loop Counter (0)
 sub.w d1,d0
 beq.s .TableLoop
 moveq #1,d3				; Two Tables Loop Counter (1)
 sub.w d1,d0
 beq.s .TableLoop
 moveq #2,d3				; Three Tables Loop Counter (2)
 sub.w d1,d0
 beq.s .TableLoop
 moveq #3,d3				; Four Tables Loop Counter (3)
 sub.w d1,d0
 bne.s .QuantizationError
.TableLoop:
 lea InverseZIGZAGMatrix(pc),a1
 moveq #0,d0
 subq.l #1,d4
 bmi.s .ImageTruncated
 move.b (a5)+,d0
 move.b d0,d1
 and.b #$f,d0
 eor.b d0,d1
 bne.s .QuantizationError		; Not an 8 Bits Quantization Table
 lsl.w #8,d0
 lea DSPStruct+4(a6),a0
 add.w d0,a0
 moveq #0,d1
 moveq #$40,d2
 sub.l d2,d4
 bmi.s .ImageTruncated
 subq.w #1,d2
.Loop:
 moveq #0,d0
 move.b (a5)+,d0
 lsl.w #8,d0
 lsl.l #4,d0
 move.l (a1)+,d1
 move.l d0,0(a0,d1.w*2)
 dbf d2,.Loop
 dbf d3,.TableLoop
 move.l d4,InCurSize(a6)
 moveq #NOERROR,d0
.End:
 movem.l (sp)+,d1-d4/a0-a1
 rts

.ImageTruncated:
 moveq #IMAGETRUNCATED,d0
 bra.s .End

.QuantizationError:			; More Than Four Tables Specified
 moveq #BADDQTMARKER,d0
 bra.s .End

;	 #] DQT Routine: 
;	 #[ DNL Routine:

DNLRoutine:
 moveq #DNLMARKER,d0
 rts

;	 #] DNL Routine: 
;	 #[ DRI Routine:

DRIRoutine:
 subq.l #4,InCurSize(a6)
 bmi.s .ImageTruncated
 move.l (a5)+,d0
 tst.w d0
 sne DRIInternalFlag(a6)		; Enable/Disable Restart
 move.w d0,DRISize(a6)			; Number of MCUs between RSTm Markers
 move.w d0,DRICurSize(a6)
 sf RSTNumber(a6)			; Start with RST0 Marker
 swap d0
 cmp.w #4,d0				; Test DRI Marker Size
 bne.s .DRIError
 moveq #NOERROR,d0
 rts

.DRIError:				; Invalid DRI Header Size
 moveq #BADDRIMARKER,d0
 rts

.ImageTruncated:
 moveq #IMAGETRUNCATED,d0
 rts

;	 #] DRI Routine: 
;	 #[ DHP Routine:

DHPRoutine:
 moveq #DHPMARKER,d0			; Error, Mode not Handled by the Decoder
 rts

;	 #] DHP Routine: 
;	 #[ EXP Routine:

EXPRoutine:
 moveq #EXPMARKER,d0			; Error, Mode not Handled by the Decoder
 rts

;	 #] EXP Routine: 
;	 #[ COM Routine:

COMRoutine:
 subq.l #2,InCurSize(a6)
 bmi.s .ImageTruncated
 moveq #0,d0
 move.w (a5)+,d0			; Marker Size
 subq.w #2,d0
 sub.l d0,InCurSize(a6)
 bmi.s .ImageTruncated
 add.l d0,a5				; Skip Marker
 moveq #NOERROR,d0
 rts

.ImageTruncated:
 moveq #IMAGETRUNCATED,d0
 rts

;	 #] COM Routine: 
;  #] Markers Routines: 
;  #[ Decode Image:

DecodeImage:
 movem.l d1-d7/a0-a4,-(sp)
 move.l MCUInBuffer(a6),a3		; 'MCU DSP Input Buffer' Pointer
 addq.w #2,a3
 move.w DUsPerMCU(a6),d3		; Number of Data Units per MCU
 lsl.w #6,d3				; *64 (Number of Coefficients per MCU)
 addq.w #1,d3				; +1 (DSP Command)
 move.w MaxXSampling(a6),d4
 mulu MaxYSampling(a6),d4
 mulu DSPReceiveSize(a6),d4
 lsl.l #6,d4				; 'DSP Output' MCU Size
 move.w XLoopCounter(a6),d5
 subq.w #1,d5				; MCUs per Row
 moveq #-1,d6				; Force Decoding of the First MCU
 move.w YLoopCounter(a6),d7
 subq.w #1,d7				; MCUs per Column
 move.l a5,d0
 add.l d0,InCurSize(a6)
 bsr DecodeHuffMCU			; Decode Current MCU
 bne EndDecode
 tst.b DRIInternalFlag(a6)
 beq.s .RestartDisabled
 subq.w #1,DRICurSize(a6)		; RSTm Marker Expected ???
 bne.s .RestartDisabled
 bsr TestRSTm
 bne EndDecode
.RestartDisabled:
 move.l a5,d0
 sub.l d0,InCurSize(a6)
 bmi.s ImageTruncated
DecodeYLoop:
 move.l MCUOutBuffer(a6),a4		; Reinit 'MCU DSP Output Buffer' Pointer
 move.w d5,d6
.DSPWorking:
 tas DSPBusyFlag
 bne.s .DSPWorking
 move.w JPEGCurrentProcess(pc),d0
 cmp.w UserHandle(a6),d0
 beq.s DecodeXLoop
 move.w UserHandle(a6),JPEGCurrentProcess
 bsr SendDSPDecoderStruct
 bsr SendDSPGammaTables
DecodeXLoop:
 clr.l -(sp)
 clr.l -(sp)
 move.l d3,-(sp)			; Input MCU Size ((DusPerMCU*64)+1)
 move.l a3,-(sp)			; Input MCU Buffer Address
 move.w #$7b,-(sp)
 trap #$e				; Send Current MCU
 lea $12(sp),sp
 move.l a5,d0
 add.l d0,InCurSize(a6)
 bsr DecodeHuffMCU			; Decode Next MCU
 bne.s DecoderError			; Test Huffman Error
 tst.b DRIInternalFlag(a6)
 beq.s .RestartDisabled
 subq.w #1,DRICurSize(a6)		; RSTm Marker Expected ???
 bne.s .RestartDisabled
 bsr TestRSTm
 bne.s DecoderError
.RestartDisabled:
 move.l a5,d0
 sub.l d0,InCurSize(a6)
 bmi.s ImageTruncated
 jmp ([DSPReceivePointer.w,a6])		; Receive Current MCU

ImageTruncated:
 moveq #IMAGETRUNCATED,d0
DecoderError:
 move.l d0,-(sp)			; Save Error Code
 move.l d4,-(sp)
 move.l a4,-(sp)
 clr.l -(sp)
 clr.l -(sp)
 move.w #$7c,-(sp)
 trap #$e				; Flush DSP
 lea $12(sp),sp
 sf DSPBusyFlag
 move.l (sp)+,d0			; Restore Error Code
EndDecode:
 movem.l (sp)+,d1-d7/a0-a4
 rts

ReceiveBytePixel:			; Receive MCU in Bytes (8 Bits)
 move.l d4,-(sp)			; Output MCU Size (in Bytes)
 move.l a4,-(sp)			; Output Buffer Address
 clr.l -(sp)
 clr.l -(sp)
 move.w #$7c,-(sp)
 trap #$e				; Receive Current MCU
 lea $12(sp),sp
 add.l d4,a4				; Increment Output Buffer Address
 subq.w #1,MCUsCounter(a6)		; Decrement User Loop Counter
 dbf d6,DecodeXLoop
 sf DSPBusyFlag
 bsr InterlaceRow
 bsr WriteOutput			; If Disk Output, Save Row
 bne.s EndDecode			; Disk Error ???
 bsr CallUserRoutine			; Call User Routine (if Defined)
 bne.s EndDecode			; User Abort ???
 dbf d7,DecodeYLoop
 moveq #NOERROR,d0
 bra.s EndDecode

ReceiveWordPixel:			; Receive MCU in Words (16 Bits)
 move.l d4,-(sp)			; Output MCU Size (in Words)
 move.l a4,-(sp)			; Output Buffer Address
 clr.l -(sp)
 clr.l -(sp)
 move.w #$7b,-(sp)
 trap #$e				; Receive Current MCU
 lea $12(sp),sp
 add.l d4,a4				; Increment Output Buffer Address
 add.l d4,a4				; (*2 Because We Received Words)
 subq.w #1,MCUsCounter(a6)		; Decrement User Loop Counter
 dbf d6,DecodeXLoop
 sf DSPBusyFlag
 bsr InterlaceRow
 bsr WriteOutput			; If Disk Output, Save Row
 bne.s EndDecode			; Disk Error ???
 bsr CallUserRoutine			; Call User Routine (if Defined)
 bne.s EndDecode			; User Abort ???
 dbf d7,DecodeYLoop
 moveq #NOERROR,d0
 bra.s EndDecode

;  #] Decode Image: 
;  #[ Huffman Routines:
;	 #[ Init Huffman Decoder:

InitHuffmanDecoder:
 clr.w ([MCUInBuffer.w,a6],2.w)		; Write DSP Command in 'MCUInBuffer'
 clr.w HuffmanCurBit(a6)		; Init. Current Huffman Bit Variable
 clr.w HuffmanCurStream(a6)		; Init. Current Huffman Bit Stream
 rts

;	 #] Init Huffman Decoder: 
;	 #[ Decode Huffman MCU:
;
; IN:
; D6 = Current XLoopCounter(a6)
; D7 = Current YLoopCounter(a6)
; OUT:
; D0 = 0 / Error
DecodeHuffMCU:
 movem.l d1-d7/a0-a4,-(sp)
 or.w d6,d7				; (XLoopCounter | YLoopCounter) == 0 ???
 beq .End
 moveq #0,d0
 moveq #0,d1
 moveq #0,d2
 moveq #0,d3
 moveq #0,d4
 moveq #0,d5
 moveq #0,d6
 sub.l a1,a1
 move.l MCUEndInBuffer(a6),a0
 move.w DUsPerMCU(a6),d7
 subq.w #1,d7
.Loop1:					; Clear MCUInBuffer
 movem.l d0-d6/a1,-(a0)
 movem.l d0-d6/a1,-(a0)
 movem.l d0-d6/a1,-(a0)
 movem.l d0-d6/a1,-(a0)
 dbf d7,.Loop1
 move.w HuffmanCurStream(a6),d0
 move.w HuffmanCurBit(a6),d2
 lea CompStruct(a6),a1
 move.l a0,a3
 lea HuffmanPaddingTable(pc),a4		; Huffman MCU Padding Table
 clr.l -(sp)				; LastDCValue Offset
.NextComponent:
 move.w (a1),d7
 bmi .EndMCU
 move.l HuffACTreePointer(a1),d6
.ComponentLoop:
 move.l HuffDCTreePointer(a1),a2	; Huffman DC Tree Pointer
 lea InverseZIGZAGMatrix+4(pc),a0	; Get ZIGZAG Reordering Table Pointer
 dbf d2,.DCBitLoop
.DCWordLoop:
 GetHuffWord
.DCBitLoop:
 GetNextBit
 dbpl d2,.DCBitLoop
 bmi.s .DCWordLoop
.DCCodeFound:
 move.l (a2),d3				; Additional Bits
 bmi .HuffmanError
 moveq #0,d1				; Cls 'Additional Bits' Register
 move.w d3,d4				; Copy Bitfield Size
 bmi.s .StoreDC
 dbf d2,.ExtractDC
.AdditionalDCLoop:
 GetHuffWord
.ExtractDC:
 add.w d0,d0
 addx.w d1,d1				; Get Additional Bits
 subq.w #1,d3
 dbmi d2,.ExtractDC
 bpl.s .AdditionalDCLoop
 btst d4,d1
 seq d3
 add.b d3,d3
 addx.w d4,d4
 add.w PaddingTable-HuffmanPaddingTable(a4,d4.w*2),d1
.StoreDC:
 add.w ([sp],LastDCValue.w,a6.l),d1
 move.w d1,([sp],LastDCValue.w,a6.l)
 move.w d1,(a3)				; Store DC Coefficient
 move.w #63*4,d5			; Maximum = 63 Word AC Huffman Codes
.ACLoop:
 move.l d6,a2				; Get AC Tree Pointer
 dbf d2,.ACBitLoop
.ACWordLoop:
 GetHuffWord
.ACBitLoop:
 GetNextBit
 dbpl d2,.ACBitLoop
 bmi.s .ACWordLoop
 move.l (a2),d3				; (SSSS.W) | (RRRR.W)*4
 beq.s .EndACCoefs			; EOB (RRRR=0, SSSS=0)
 sub.w d3,d5				; Decrement Loop Counter
 add.w d3,a0				; Skip D1.W Null Coefficients in ZIGZAG Table
 swap d3				; Get SSSS
 subq.w #1,d3				; (SSSS.W)-1
 bmi.s .NoAdditionalBits		; Test ZRL (No Bitfield)
 move.w d3,d4				; Copy Bitfield Size (SSSS.W)-1
 moveq #0,d1
 dbf d2,.ExtractAC
.AdditionalACLoop:
 GetHuffWord
.ExtractAC:
 add.w d0,d0
 addx.w d1,d1				; Get Additional Bits
 subq.w #1,d3
 dbmi d2,.ExtractAC
 bpl.s .AdditionalACLoop
 btst d4,d1
 seq d3
 add.b d3,d3
 addx.w d4,d4
 add.w PaddingTable-HuffmanPaddingTable(a4,d4.w*2),d1
 move.w d1,([a0],a3.l)			; Store ZIGZAG Reordered AC Coefficient
.NoAdditionalBits:
 addq.w #4,a0				; Update Output ZIGZAG Offset Pointer
 subq.w #4,d5				; Decrement AC Coefficients Counter
 bgt.s .ACLoop
 bmi.s .HuffmanError
.EndACCoefs:
 lea $80(a3),a3
 dbf d7,.ComponentLoop
 lea JPEGCompStruct(a1),a1
 addq.l #2,(sp)				; Next DC Value Offset
 bra .NextComponent
.EndMCU:
 addq.w #4,sp
 move.w d0,HuffmanCurStream(a6)		; Save Current Bits
 move.w d2,HuffmanCurBit(a6)		; Save Current Bits Counter
.End:
 moveq #NOERROR,d0
 movem.l (sp)+,d1-d7/a0-a4
 rts

.HuffmanError:
 addq.w #4,sp
 moveq #HUFFMANERROR,d0			; Buggy Huffman Stream
 movem.l (sp)+,d1-d7/a0-a4
 rts

;	 #] Decode Huffman MCU: 
;	 #[ Generate Huffman DC Tree:
;
; IN:
; D0 = Huffman Tree Number (0, 1)
; OUT:
; D0 = 0 / Error
GenHuffmanDCTree:
 movem.l d1-d7/a0-a4,-(sp)
 move.w d0,d7
 lea HuffTmpTable(a6),a1
 moveq #$10,d0
 sub.l d0,InCurSize(a6)
 bmi .ImageTruncated
 lea $10(a5),a2
 subq.w #1,d0
.CountLevelsLoop:
 tst.b -(a2)
 dbne d0,.CountLevelsLoop		; Count Used Levels
 move.w d0,d6				; D6 = Used Levels - 1
 move.l a0,a2
 move.l a1,a3
 moveq #0,d0
 moveq #1,d1
 moveq #0,d3
 moveq #0,d4
 sub.l a4,a4
 move.w d6,d5
.CreateRealSizeLoop:			; Count Needed Nodes for Huffman Tree
 move.w d1,d2
 sub.w d0,d2
 add.w d2,d3
 move.w d2,(a3)+
 add.w d0,d0
 move.b (a2)+,d4
 move.w d4,(a3)+
 add.w d4,a4
 add.w d4,d0
 add.w d1,d1
 dbf d5,.CreateRealSizeLoop		; D3 = Real Nodes in Huffman Tree
 ext.l d5
 move.l d5,(a3)				; End Of Tree Marker (-1)
 lea $10(a5),a5				; Skip Huffman Descriptor
 move.l a4,d4				; D4 = Number of Huffman Codes
 add.w d3,d4				; + Real Nodes In Tree
 addq.w #1,d4				; + Dead Code
 lsl.w #2,d4
 move.l d4,d0
 bsr Malloc
 bne.s .End
 move.l a0,HuffDCPointers(a6,d7.w*4)
 lea 0(a0,d3.w*4),a2			; Final Codes Pointer
 lea 0(a0,d3.w*4),a0			; Tree Pointer
 move.l a0,HuffDCTrees(a6,d7.w*4)
 subq.l #2,HuffDCTrees(a6,d7.w*4)
.LinksLoop:
 move.l a2,d0
 sub.l a0,d0
 addq.w #2,d0
 move.w (a1)+,d2
 bpl.s .EndKillLinks
 subq.w #4,d0
 moveq #-1,d5
 move.l d5,(a2)+
.KillLinksLoop:
 tst.w (a0)
 bpl.s .EndTree
 move.w d0,(a0)+
 tst.w (a0)
 bpl.s .EndTree
 move.w d0,(a0)+
 subq.w #4,d0
 bra.s .KillLinksLoop
.EndKillLinks:
 move.w d2,d3
 lsl.w #2,d3
 neg.w d3
 move.w (a1)+,d1
 beq.s .No0Link
.FinalLinksLoop:
 subq.w #1,d1
 bmi.s .No0Link
 subq.w #1,d2
 move.w d0,-(a0)
 subq.l #1,InCurSize(a6)
 bmi.s .ImageTruncated
 moveq #0,d5
 move.b (a5)+,d5
 subq.w #1,d5
 move.l d5,(a2)+
 addq.w #4,d0
 subq.w #1,d1
 bmi.s .No1Link
 move.w d0,-(a0)
 subq.l #1,InCurSize(a6)
 bmi.s .ImageTruncated
 moveq #0,d5
 move.b (a5)+,d5
 subq.w #1,d5
 move.l d5,(a2)+
 addq.w #4,d3
 addq.w #8,d0
 bra.s .FinalLinksLoop
.NoLinksLoop:
 move.w d3,-(a0)
 subq.w #4,d3
.No1Link:
 move.w d3,-(a0)
.No0Link:
 dbf d2,.NoLinksLoop
 bra.s .LinksLoop
.EndTree:
 moveq #NOERROR,d0
.End:
 movem.l (sp)+,d1-d7/a0-a4
 rts

.ImageTruncated:
 moveq #IMAGETRUNCATED,d0
 bra.s .End

;	 #] Generate Huffman DC Tree: 
;	 #[ Generate Huffman AC Tree:
;
; IN:
; D0 = Huffman Tree Number (0, 1)
; OUT:
; D0 = 0 / Error
GenHuffmanACTree:
 movem.l d1-d7/a0-a4,-(sp)
 move.w d0,d7
 lea HuffTmpTable(a6),a1
 moveq #$10,d0
 sub.l d0,InCurSize(a6)
 bmi .ImageTruncated
 lea $10(a5),a2
 subq.w #1,d0
.CountLevelsLoop:
 tst.b -(a2)
 dbne d0,.CountLevelsLoop		; Count Used Levels
 move.w d0,d6				; D6 = Used Levels - 1
 move.l a0,a2
 move.l a1,a3
 moveq #0,d0
 moveq #1,d1
 moveq #0,d3
 moveq #0,d4
 sub.l a4,a4
 move.w d6,d5
.CreateRealSizeLoop:			; Count Needed Nodes for Huffman Tree
 move.w d1,d2
 sub.w d0,d2
 add.w d2,d3
 move.w d2,(a3)+
 add.w d0,d0
 move.b (a2)+,d4
 move.w d4,(a3)+
 add.w d4,a4
 add.w d4,d0
 add.w d1,d1
 dbf d5,.CreateRealSizeLoop		; D3 = Real Nodes in Huffman Tree
 ext.l d5
 move.l d5,(a3)				; End Of Tree Marker
 lea $10(a5),a5				; Skip Huffman Descriptor
 move.l a4,d4				; D4 = Number of Huffman Codes
 add.w d3,d4				; + Real Nodes In Tree
 addq.w #1,d4				; + Dead Codes
 lsl.w #2,d4
 move.l d4,d0
 bsr Malloc
 bne .End
 move.l a0,HuffACPointers(a6,d7.w*4)
 lea 0(a0,d3.w*4),a2			; Final Codes Pointer
 lea 0(a0,d3.w*4),a0			; Tree Pointer
 move.l a0,HuffACTrees(a6,d7.w*4)
 subq.l #2,HuffACTrees(a6,d7.w*4)
.LinksLoop:
 move.l a2,d0
 sub.l a0,d0
 addq.w #2,d0
 move.w (a1)+,d2
 bpl.s .EndKillLinks
 subq.w #4,d0
 moveq #-1,d5
 move.l d5,(a2)+
.KillLinksLoop:
 tst.w (a0)
 bpl.s .EndTree
 move.w d0,(a0)+
 tst.w (a0)
 bpl.s .EndTree
 move.w d0,(a0)+
 subq.w #4,d0
 bra.s .KillLinksLoop
.EndKillLinks:
 move.w d2,d3
 lsl.w #2,d3
 neg.w d3
 move.w (a1)+,d1
 beq.s .No0Link
.FinalLinksLoop:
 subq.w #1,d1
 bmi.s .No0Link
 subq.w #1,d2
 move.w d0,-(a0)
 subq.l #1,InCurSize(a6)
 bmi.s .ImageTruncated
 moveq #$f,d5
 and.b (a5),d5
 swap d5
 move.b (a5)+,d5
 lsr.w #4,d5
 lsl.w #2,d5
 move.l d5,(a2)+
 addq.w #4,d0
 subq.w #1,d1
 bmi.s .No1Link
 move.w d0,-(a0)
 subq.l #1,InCurSize(a6)
 bmi.s .ImageTruncated
 moveq #$f,d5
 and.b (a5),d5
 swap d5
 move.b (a5)+,d5
 lsr.w #4,d5
 lsl.w #2,d5
 move.l d5,(a2)+
 addq.w #4,d3
 addq.w #8,d0
 bra.s .FinalLinksLoop
.NoLinksLoop:
 move.w d3,-(a0)
 subq.w #4,d3
.No1Link:
 move.w d3,-(a0)
.No0Link:
 dbf d2,.NoLinksLoop
 bra.s .LinksLoop
.EndTree:
 moveq #NOERROR,d0
.End:
 movem.l (sp)+,d1-d7/a0-a4
 rts

.ImageTruncated:
 moveq #IMAGETRUNCATED,d0
 bra.s .End

;	 #] Generate Huffman AC Tree: 
;  #] Huffman Routines: 
;  #[ Interlacing Routines:
;	 #[ Init MCU Interlacing:
;
; OUT:
; D0 = 0 / Error
;
InitMCUInterlacing:
 movem.l d1-d4/a0-a1,-(sp)
 move.w MaxXSampling(a6),d0
 subq.w #1,d0
 lsl.w #2,d0
 move.w MaxYSampling(a6),d4
 add.w d4,d0
 subq.w #1,d0
 mulu MaxXSampling(a6),d4
 subq.w #1,d4
 move.w OutPixelSize(a6),d2
 lsl.w #3,d2
 move.w d2,d3
 mulu MaxXSampling(a6),d3
 mulu XLoopCounter(a6),d3
 lsl.l #3,d3
 move.l (InterlacingOffsetPointers.w,pc,d0.w*4),a0
 lea InterlacingOffsets(a6),a1
.Loop:
 move.w (a0)+,d0
 mulu d2,d0
 move.w (a0)+,d1
 mulu d3,d1
 add.l d0,d1
 move.l d1,(a1)+
 dbf d4,.Loop
 move.w OutPixelSize(a6),d0
 subq.w #1,d0
 move.l (InterlacingRoutinePointers.w,pc,d0.w*4),InterlacingRoutine(a6)
 move.l OutPointer(a6),OutTmpPointer(a6)
 move.w OutMFDB+MFDBWordSize(a6),d0
 mulu MaxYSampling(a6),d0
 lsl.l #4,d0
 move.l d0,OutInternalSize(a6)
 move.w MaxYSampling(a6),d0
 lsl.w #3,d0
 move.w d0,OutTmpHeight(a6)
 moveq #NOERROR,d0
 tst.w OutFlag(a6)
 beq.s .End
.DiskOutput:
 bsr Malloc
 bne.s .End
 move.l a0,OutTmpPointer(a6)
 clr.l OutInternalSize(a6)
 moveq #NOERROR,d0
.End:
 movem.l (sp)+,d1-d4/a0-a1
 rts

;	 #] Init MCU Interlacing: 
;	 #[ Interlace Row:

InterlaceRow:
 jmp ([InterlacingRoutine.w,a6])

;	 #] Interlace Row: 
;	 #[ Interlace 1 Byte MCU:

Interlace1ByteMCU:
 movem.l d3-d7/a0-a4,-(sp)
 move.l MCUOutBuffer(a6),a0
 move.l OutTmpPointer(a6),a1
 move MaxXSampling(a6),d3
 lsl.l #3,d3
 moveq #0,d5
 move.w OutMFDB+MFDBWordSize(a6),d5
 add.w d5,d5
 subq.w #8,d5
 move.w XLoopCounter(a6),d7
 subq.w #1,d7
.RowLoop:
 lea InterlacingOffsets(a6),a4
 move.w MaxXSampling(a6),d6
 mulu MaxYSampling(a6),d6
 subq.w #1,d6
.DULoop:
 move.l a1,a2
 add.l (a4)+,a2
 moveq #7,d4
.Loop:
 move.l (a0)+,(a2)+
 move.l (a0)+,(a2)+
 add.w d5,a2
 dbf d4,.Loop
 dbf d6,.DULoop
 add.w d3,a1
 dbf d7,.RowLoop
 move.l OutInternalSize(a6),d7
 add.l d7,OutTmpPointer(a6)
 movem.l (sp)+,d3-d7/a0-a4
 rts

;	 #] Interlace 1 Byte MCU: 
;	 #[ Interlace 2 Bytes MCU:

Interlace2BytesMCU:
 movem.l d3-d7/a0-a4,-(sp)
 move.l MCUOutBuffer(a6),a0
 move.l OutTmpPointer(a6),a1
 move MaxXSampling(a6),d3
 lsl.w #4,d3
 moveq #0,d5
 move.w OutMFDB+MFDBWordSize(a6),d5
 add.w d5,d5
 sub.w #$10,d5
 move.w XLoopCounter(a6),d7
 subq.w #1,d7
.RowLoop:
 lea InterlacingOffsets(a6),a4
 move.w MaxXSampling(a6),d6
 mulu MaxYSampling(a6),d6
 subq.w #1,d6
.DULoop:
 move.l a1,a2
 add.l (a4)+,a2
 moveq #7,d4
.Loop:
 move.l (a0)+,(a2)+
 move.l (a0)+,(a2)+
 move.l (a0)+,(a2)+
 move.l (a0)+,(a2)+
 add.w d5,a2
 dbf d4,.Loop
 dbf d6,.DULoop
 add.w d3,a1
 dbf d7,.RowLoop
 move.l OutInternalSize(a6),d7
 add.l d7,OutTmpPointer(a6)
 movem.l (sp)+,d3-d7/a0-a4
 rts

;	 #] Interlace 2 Bytes MCU: 
;	 #[ Interlace 3 Bytes MCU:

Interlace3BytesMCU:
 movem.l d3-d7/a0-a4,-(sp)
 move.l MCUOutBuffer(a6),a0
 move.l OutTmpPointer(a6),a1
 move MaxXSampling(a6),d3
 mulu #$18,d3
 moveq #0,d5
 move.w OutMFDB+MFDBWordSize(a6),d5
 add.w d5,d5
 sub.w #$18,d5
 move.w XLoopCounter(a6),d7
 subq.w #1,d7
.RowLoop:
 lea InterlacingOffsets(a6),a4
 move.w MaxXSampling(a6),d6
 mulu MaxYSampling(a6),d6
 subq.w #1,d6
.DULoop:
 move.l a1,a2
 add.l (a4)+,a2
 moveq #7,d4
.Loop:
 move.l (a0)+,(a2)+
 move.l (a0)+,(a2)+
 move.l (a0)+,(a2)+
 move.l (a0)+,(a2)+
 move.l (a0)+,(a2)+
 move.l (a0)+,(a2)+
 add.w d5,a2
 dbf d4,.Loop
 dbf d6,.DULoop
 add.w d3,a1
 dbf d7,.RowLoop
 move.l OutInternalSize(a6),d7
 add.l d7,OutTmpPointer(a6)
 movem.l (sp)+,d3-d7/a0-a4
 rts

;	 #] Interlace 3 Bytes MCU: 
;	 #[ Interlace 4 Bytes MCU:

Interlace4BytesMCU:
 movem.l d3-d7/a0-a4,-(sp)
 move.l MCUOutBuffer(a6),a0
 move.l OutTmpPointer(a6),a1
 move MaxXSampling(a6),d3
 lsl.l #5,d3
 moveq #0,d5
 move.w OutMFDB+MFDBWordSize(a6),d5
 add.w d5,d5
 sub.w #$20,d5
 move.w XLoopCounter(a6),d7
 subq.w #1,d7
.RowLoop:
 lea InterlacingOffsets(a6),a4
 move.w MaxXSampling(a6),d6
 mulu MaxYSampling(a6),d6
 subq.w #1,d6
.DULoop:
 move.l a1,a2
 add.l (a4)+,a2
 moveq #7,d4
.Loop:
 move.l (a0)+,(a2)+
 move.l (a0)+,(a2)+
 move.l (a0)+,(a2)+
 move.l (a0)+,(a2)+
 move.l (a0)+,(a2)+
 move.l (a0)+,(a2)+
 move.l (a0)+,(a2)+
 move.l (a0)+,(a2)+
 add.w d5,a2
 dbf d4,.Loop
 dbf d6,.DULoop
 add.w d3,a1
 dbf d7,.RowLoop
 move.l OutInternalSize(a6),d7
 add.l d7,OutTmpPointer(a6)
 movem.l (sp)+,d3-d7/a0-a4
 rts

;	 #] Interlace 4 Bytes MCU: 
;  #] Interlacing Routines: 
;  #[ Miscellaneous Routines:
;	 #[ Generate Expansion Value:
;
; IN:
; D1: X Sampling
; D2: Y Sampling
; OUT:
; D0 = 0 / Error
GenExpandValue:
 movem.l d1/a0,-(sp)
 lea ExpStruct(a6),a0
 move.w ExpandOffset(a6),d0
 clr.w 0(a0,d0.w)
 tst.w d1
 beq.s .BadSubSampling
 cmp.w #4,d1
 bhi.s .BadSubSampling
 tst.w d2
 beq.s .BadSubSampling
 cmp.w #4,d2
 bhi.s .BadSubSampling
 move.w d1,XNumber(a0,d0.w)
 move.w d2,YNumber(a0,d0.w)
 move.w #-1,JPEGExpStruct(a0,d0.w)
 addq.w #JPEGExpStruct,ExpandOffset(a6)
 cmp.w #1,InComponents(a6)
 beq.s .OneChannel
 mulu d2,d1
 add.w d1,ExpandSize(a6)
 cmp.w #10,ExpandSize(a6)
 bgt.s .BadSubSampling
.OneChannel:
 moveq #NOERROR,d0
.End:
 movem.l (sp)+,d1/a0
 rts

.BadSubSampling:
 moveq #BADSUBSAMPLING,d0
 bra.s .End

;	 #] Generate Expansion Value: 
;	 #[ Calculate Max. Sampling:

CalcMaxSampling:
 movem.l d5-d7/a0,-(sp)
 moveq #0,d6				; Init Maximum X Sampling
 moveq #0,d7				; Init Maximum Y Sampling
 lea ExpStruct(a6),a0
.Loop:
 tst.w (a0)
 bmi.s .EndLoop
 move.w (a0),d5				; XNumber(a0) (Optimisation)
 cmp.w d5,d6
 bge.s .XSmaller
 move.w d5,d6				; New Maximum X Sampling
.XSmaller:
 move.w YNumber(a0),d5
 cmp.w d5,d7
 bge.s .YSmaller
 move.w d5,d7				; New Maximum Y Sampling
.YSmaller:
 addq.w #JPEGExpStruct,a0
 bra.s .Loop
.EndLoop:
 move.w d6,MaxXSampling(a6)		; Maximum X Sampling in Scan
 move.w d7,MaxYSampling(a6)		; Maximum Y Sampling in Scan
.End:
 movem.l (sp)+,d5-d7/a0
 rts

;	 #] Calculate Max. Sampling: 
;	 #[ Calculate Pixel Format:

CalculatePixelFormat:
 move.w OutComponents(a6),d0
 subq.w #1,d0
 lsl.w #2,d0
 add.w OutPixelSize(a6),d0
 subq.w #1,d0
 move.l .ReceiveTable(pc,d0.w*8),DSPReceivePointer(a6)
 beq.s .BadFormat
 move.w .ReceiveTable+6(pc,d0.w*8),DSPReceiveSize(a6)
 moveq #NOERROR,d0
 rts

.BadFormat:
 moveq #BADPIXELFORMAT,d0
 rts

.ReceiveTable:
 dc.l ReceiveBytePixel,1		; Receive 1 Component (1 Byte)
 dc.l 0,0
 dc.l 0,0
 dc.l 0,0

 dc.l 0,0
 dc.l ReceiveBytePixel,2		; Receive 2 Components (2 Bytes)
 dc.l 0,0
 dc.l 0,0

 dc.l 0,0
 dc.l ReceiveWordPixel,1		; Receive 3 Components (1 Word)
 dc.l ReceiveBytePixel,3		; Receive 3 Components (3 Bytes)
 dc.l ReceiveBytePixel,4		; receive 4 Components (4 Bytes)

 dc.l 0,0
 dc.l 0,0
 dc.l 0,0
 dc.l ReceiveBytePixel,4		; Receive 4 Components (4 Bytes)

;	 #] Calculate Pixel Format: 
;	 #[ Call User Routine:
;
; OUT:
; D0 = 0 / USERABORT
CallUserRoutine:
 movem.l d3-d7/a3-a6,-(sp)
 move.l UserRoutinePtr(a6),d0		; User Routine Pointer ???
 beq.s .End
 move.l a6,a0				; A0 = JPEG Decoder Structure
 jsr (d0.l)				; Call User Routine (Return Code Should be 0 / -1)
 and.w #USERABORT,d0
.End:
 movem.l (sp)+,d3-d7/a3-a6
 rts

;	 #] Call User Routine: 
;	 #[ Get SOFn:
;
; OUT:
; D0 = 0 / Error
; A0 = SOFn Pointer
GetSOFn:
 movem.l d1-d2/a5,-(sp)
 move.l (a6),a5				; InPointer(a6) (Optimization)
 move.l InCurSize(a6),d2
 lea .SOFnTable(pc),a0
 subq.l #2,d2
 bmi.s .ImageTruncated
 move.w (a5)+,d0
 cmp.w #$ffd8,d0			; Test SOI Marker
 bne.s .UnknownFormat
.GetMarkerLoop:
 moveq #0,d0
 subq.l #1,d2
 bmi.s .ImageTruncated
 move.b (a5)+,d0
 addq.b #1,d0				; Test $FF (Marker)
 bne.s .MissingMarker
.FFLoop:
 subq.l #1,d2
 bmi.s .ImageTruncated
 move.b (a5)+,d0
 not.b d0
 beq.s .FFLoop				; Skip $FF (Fill Bytes)
 not.b d0
 move.w d0,d1
 and.w #$f0,d0
 cmp.w #$c0,d0
 bne.s .SkipMarker
 eor.w d1,d0
 move.b 0(a0,d0.w),d0
 bne.s .SOFnFound
.SkipMarker:
 subq.l #2,d2
 bmi.s .ImageTruncated
 moveq #0,d0
 move.w (a5),d0
 add.w d0,a5
 sub.l d0,d2
 bmi.s .ImageTruncated
 bra.s .GetMarkerLoop
.SOFnFound:
 extb.l d0
 bpl.s .End				; Marker not Handled
 move.l a5,a0
 moveq #NOERROR,d0
 move.l d2,InCurSize(a6)
.End:
 tst.w d0
 movem.l (sp)+,d1-d2/a5
 rts

.ImageTruncated:
 moveq #IMAGETRUNCATED,d0
 rts

.UnknownFormat:
 moveq #UNKNOWNFORMAT,d0
 bra.s .End

.MissingMarker:
 moveq #MISSINGMARKER,d0
 bra.s .End

.SOFnTable:
 dc.b -1			; SOF0, Handled
 dc.b SOF1MARKER		; SOF1, Not Handled
 dc.b SOF2MARKER		; SOF2, Not Handled
 dc.b SOF3MARKER		; SOF3, Not Handled
 dc.b 0
 dc.b SOF5MARKER		; SOF5, Not Handled
 dc.b SOF6MARKER		; SOF6, Not Handled
 dc.b SOF7MARKER		; SOF7, Not Handled
 dc.b 0
 dc.b SOF9MARKER		; SOF9, Not Handled
 dc.b SOF10MARKER		; SOF10, Not Handled
 dc.b SOF11MARKER		; SOF11, Not Handled
 dc.b 0
 dc.b SOF13MARKER		; SOF13, Not Handled
 dc.b SOF14MARKER		; SOF14, Not Handled
 dc.b SOF15MARKER		; SOF15, Not Handled

 even

;	 #] Get SOFn: 
;	 #[ Test RSTm:

TestRSTm:
 tst.w d7				; Test if Last Row
 bne.s .TestRSTm
 cmp.w #1,d6				; No RST Marker After Last MCU
 ble.s .End
.TestRSTm:
 move.w HuffmanCurBit(a6),d0		; Resync. JPEG Datas Pointer
 subq.w #8,d0
 bmi.s .NoSync
 subq.w #2,a5
.NoSync:
 clr.w HuffmanCurBit(a6)		; Reinit Huffman Variables
 clr.w HuffmanCurStream(a6)
 clr.l LastDCValue(a6)			; Reinit DC Values
 clr.l LastDCValue+4(a6)
 moveq #-1,d0
.SkipFFLoop:
 cmp.b (a5)+,d0
 beq.s .SkipFFLoop			; Skip Any $FF Byte
 move.b -1(a5),d0
 sub.b #$d0,d0
 cmp.b RSTNumber(a6),d0			; Test if Correct RST Marker
 bne.s .BadRSTmMarker
 addq.b #1,RSTNumber(a6)		; Increment Current RST Marker Number
 and.b #7,RSTNumber(a6)			; Modulo 7
 move.w DRISize(a6),DRICurSize(a6)	; Reinit Restart Interval Current Size
.End:
 moveq #NOERROR,d0
 rts

.ExpectedRSTmMarker:
 moveq #NORSTmMARKER,d0
 rts

.BadRSTmMarker:
 moveq #BADRSTmMARKER,d0
 rts

;	 #] Test RSTm: 
;	 #[ Create MFDB:

CreateMFDB:
 movem.l d0-d1/a0,-(sp)
 lea OutMFDB(a6),a0
 tst.w OutFlag(a6)
 bne.s .NoMFDBAddress
 move.l OutPointer(a6),(a0)		; MFDBAddress(a0) (Optimization)
.NoMFDBAddress:
 clr.w MFDBFormatFlag(a0)
 move.w OutPixelSize(a6),d0
 lsl.w #3,d0
 move.w d0,MFDBBitPlanes(a0)
 movem.l (sp)+,d0-d1/a0
 rts

;	 #] Create MFDB: 
;	 #[ Wait:

Wait:
 movem.l d0-d2/a0-a2,-(sp)
 pea .Wait(pc)
 move.w #$26,-(sp)
 trap #$e
 addq.w #6,sp
 movem.l (sp)+,d0-d2/a0-a2
 rts

.Wait:
 move.l $4ba.w,d0
 add.l #300,d0				; Wait 1.5 Second
.Synchro:
 cmp.l $4ba.w,d0
 bhi.s .Synchro
 rts

;	 #] Wait: 
;  #] Miscellaneous Routines: 
;  #[ DSP Routines:
;	 #[ Install DSP Decoder:
;
; OUT:
; D0 = 0 / Error
InstallDSPDecoder:
 movem.l d1-d2/a0-a2,-(sp)
 bsr DSPLock
 bne.s .End
 move.w #$72,-(sp)
 trap #$e				; DSPGetProgAbility
 addq.w #2,sp
 sub.w #'JD',d0				; Test if JPEG Decoder Ability
 beq.s .End
 pea -4(sp)
 pea -4(sp)
 move.w #$6a,-(sp)
 trap #$e				; DSPAvailable
 movem.l 2(sp),d0-d1
 lea $a(sp),sp
 cmp.l #$2000,d0			; X Memory
 blt.s .DSPMemoryError
 cmp.l #$2e00,d1			; Y Memory
 blt.s .DSPMemoryError
 move.l #$2e00,-(sp)
 move.l #$2000,-(sp)
 move.w #$6b,-(sp)
 trap #$e				; DSPReserve
 lea $a(sp),sp
 tst.w d0
 bmi.s .DSPMemoryError
 move.w #'JD',-(sp)
 move.l #DSPEndCode-DSPCode,d1
 divu #3,d1
 ext.l d1
 move.l d1,-(sp)
 lea DSPCode(pc),a0
 move.l a0,-(sp)
 move.w #$6d,-(sp)
 trap #$e				; DSPExecProg
 lea $c(sp),sp
 moveq #NOERROR,d0
.End:
 tst.w d0
 movem.l (sp)+,d1-d2/a0-a2
 rts

.DSPMemoryError:
 moveq #DSPMEMORYERROR,d0
 bra.s .End

;	 #] Install DSP Decoder: 
;	 #[ Send DSP Gamma Tables:

SendDSPGammaTables:
 movem.l d0-d5/a0-a4,-(sp)
.DSPWorking:
 tas DSPBusyFlag
 bne.s .DSPWorking
 move.w UserHandle(a6),JPEGCurrentProcess
 lea Comp1GammaPtr(a6),a3
 lea GammaBuffer(pc),a4
 moveq #3,d0
 move.l d0,(a4)
 move.l #GAMMAPOINTER,d2
 move.w OutComponents(a6),d3
 move.l #GAMMASIZE+2,d4
 cmp.w #3,d3
 bne.s .8BitsTables
 cmp.w #2,OutPixelSize(a6)
 beq.s .5BitsTables
.8BitsTables:
 subq.w #1,d3
.8BitsTableLoop:
 lea DefaultGammaTable(pc),a0
 move.l (a3)+,d0
 beq.s .Default8BitsTable
.User8BitsTable:
 move.l d0,a0
.Default8BitsTable:
 move.l d2,4(a4)
 bsr .Build8BitsTable
 move.l a4,a0
 move.l d4,d0
 bsr DSPBlkUnpacked
 add.l #GAMMASIZE,d2
 dbf d3,.8BitsTableLoop
 sf DSPBusyFlag
 movem.l (sp)+,d0-d5/a0-a4
 rts

.5BitsTables:
 lea DefaultGammaTable(pc),a0
 move.l (a3)+,d0
 beq.s .Default5BitsRedTable
.User5BitsRedTable:
 move.l d0,a0
.Default5BitsRedTable:
 move.l d2,4(a4)
 bsr.s .Build5BitsRedTable
 move.l a4,a0
 move.l d4,d0
 bsr DSPBlkUnpacked
 add.l #GAMMASIZE,d2
 lea DefaultGammaTable(pc),a0
 move.l (a3)+,d0
 beq.s .Default5BitsGreenTable
.User5BitsGreenTable:
 move.l d0,a0
.Default5BitsGreenTable:
 move.l d2,4(a4)
 bsr .Build5BitsGreenTable
 move.l a4,a0
 move.l d4,d0
 bsr DSPBlkUnpacked
 add.l #GAMMASIZE,d2
 lea DefaultGammaTable(pc),a0
 move.l (a3)+,d0
 beq.s .Default5BitsBlueTable
.User5BitsBlueTable:
 move.l d0,a0
.Default5BitsBlueTable:
 move.l d2,4(a4)
 bsr .Build5BitsBlueTable
 move.l a4,a0
 move.l d4,d0
 bsr DSPBlkUnpacked
 sf DSPBusyFlag
 movem.l (sp)+,d0-d5/a0-a4
 rts

.Build8BitsTable:
 lea 8(a4),a1
 moveq #0,d0
 move.b (a0),d0
 moveq #$7f,d1
.8BitsLoop1:
 move.l d0,(a1)+
 dbf d1,.8BitsLoop1
 lsr.w #8,d1
.8BitsLoop2:
 move.b (a0)+,d0
 move.l d0,(a1)+
 dbf d1,.8BitsLoop2
 move.b -(a0),d0
 moveq #$7f,d1
.8BitsLoop3:
 move.l d0,(a1)+
 dbf d1,.8BitsLoop3
 rts

.Build5BitsRedTable:
 lea 8(a4),a1
 move.l #$0000f800,d5
 move.b (a0),d0
 ror.w #8,d0
 and.l d5,d0
 moveq #$7f,d1
.5BitsRedLoop1:
 move.l d0,(a1)+
 dbf d1,.5BitsRedLoop1
 lsr.w #8,d1
.5BitsRedLoop2:
 move.b (a0)+,d0
 ror.w #8,d0
 and.l d5,d0
 move.l d0,(a1)+
 dbf d1,.5BitsRedLoop2
 move.b -(a0),d0
 ror.w #8,d0
 and.l d5,d0
 moveq #$7f,d1
.5BitsRedLoop3:
 move.l d0,(a1)+
 dbf d1,.5BitsRedLoop3
 rts

.Build5BitsGreenTable:
 lea 8(a4),a1
 move.l #$000007c0,d5
 move.b (a0),d0
 lsl.w #3,d0
 and.l d5,d0
 moveq #$7f,d1
.5BitsGreenLoop1:
 move.l d0,(a1)+
 dbf d1,.5BitsGreenLoop1
 lsr.w #8,d1
.5BitsGreenLoop2:
 move.b (a0)+,d0
 lsl.w #3,d0
 and.l d5,d0
 move.l d0,(a1)+
 dbf d1,.5BitsGreenLoop2
 move.b -(a0),d0
 lsl.w #3,d0
 and.l d5,d0
 moveq #$7f,d1
.5BitsGreenLoop3:
 move.l d0,(a1)+
 dbf d1,.5BitsGreenLoop3
 rts

.Build5BitsBlueTable:
 lea 8(a4),a1
 moveq #0,d0
 move.b (a0),d0
 lsr.w #3,d0
 moveq #$7f,d1
.5BitsBlueLoop1:
 move.l d0,(a1)+
 dbf d1,.5BitsBlueLoop1
 lsr.w #8,d1
.5BitsBlueLoop2:
 move.b (a0)+,d0
 lsr.w #3,d0
 move.l d0,(a1)+
 dbf d1,.5BitsBlueLoop2
 move.b -(a0),d0
 lsr.w #3,d0
 moveq #$7f,d1
.5BitsBlueLoop3:
 move.l d0,(a1)+
 dbf d1,.5BitsBlueLoop3
 rts

;	 #] Send DSP Gamma Tables: 
;	 #[ Create DSP Decoder Struct:

CreateDSPDecoderStruct:
 movem.l d0-d3/a0-a3,-(sp)
 lea DSPStruct(a6),a0
 move.l #1,(a0)				; DSPStructMagic(a0) (Optimization)
 moveq #0,d0
 move.w DUsPerMCU(a6),d0
 lsl.l #5,d0
 move.l d0,DSPMCUInSize(a0)
 moveq #0,d0
 move.w InComponents(a6),d0
 move.l d0,DSPInComponents(a0)
 moveq #3,d3
 lea Comp1DU(a0),a1
 lea ComponentsIDs(a6),a2
 moveq #0,d0
 move.w MaxXSampling(a6),d0
 subq.w #1,d0
 lsl.w #2,d0
 add.w MaxYSampling(a6),d0
 subq.w #1,d0
 move.l (DSPExpandDUTable.w,pc,d0.w*4),a3
.ComponentLoop:
 move.w (a2)+,d2
 bmi.s .EmptyComponentLoop
 moveq #0,d0
 moveq #0,d1
 move.b (ComponentsInternal+1.w,a6,d2.w*4),d0
 move.b (ComponentsInternal+2.w,a6,d2.w*4),d1
 mulu d0,d1
 move.l d1,(a1)+
 move.b (ComponentsInternal+3.w,a6,d2.w*4),d1
 move.l (DSPDequantizationTable.w,pc,d1.w*4),(a1)+
 dbf d3,.ComponentLoop
 bra.s .AfterComponents
.EmptyComponentLoop:
 not.l (a1)+
 not.l (a1)+
 dbf d3,.EmptyComponentLoop
.AfterComponents:
 move.w MaxXSampling(a6),d0
 mulu MaxYSampling(a6),d0
 lsl.l #5,d0
 move.l d0,DSPMCUOutSize(a0)
 move.w InComponents(a6),d0
 subq.w #1,d0
 lsl.w #2,d0
 add.w OutComponents(a6),d0
 subq.w #1,d0
 move.b (DSPConvertMCUTable.w,pc,d0.w),d1
 extb.l d1
 move.l d1,DSPColorSpaceMagic(a0)
 move.w InComponents(a6),d0
 subq.w #1,d0
 lsl.w #2,d0
 add.w OutPixelSize(a6),d0
 subq.w #1,d0
 move.b (DSPSendMCUTable.w,pc,d0.w),d1
 extb.l d1
 move.l d1,DSPSendMCUMagic(a0)
 not.l DSPComp1ExpMagic(a0)
 not.l DSPComp2ExpMagic(a0)
 not.l DSPComp3ExpMagic(a0)
 not.l DSPComp4ExpMagic(a0)
 lea DSPComp1ExpMagic(a0),a1
 lea ComponentsIDs(a6),a2
 moveq #3,d3
.ExpansionLoop:
 move.w (a2)+,d2
 bmi.s .AfterExpansion
 moveq #0,d0
 move.b (ComponentsInternal+1.w,a6,d2.w*4),d0
 subq.w #1,d0
 mulu MaxYSampling(a6),d0
 add.b (ComponentsInternal+2.w,a6,d2.w*4),d0
 subq.w #1,d0
 move.b 0(a3,d0.w),d0
 extb.l d0
 move.l d0,(a1)+
 dbf d3,.ExpansionLoop
.AfterExpansion:
 movem.l (sp)+,d0-d3/a0-a3
 rts

;	 #] Create DSP Decoder Struct: 
;	 #[ Send DSP Decoder Struct:

SendDSPDecoderStruct:
 movem.l d0/a0,-(sp)
.DSPWorking:
 tas DSPBusyFlag
 bne.s .DSPWorking
 move.w UserHandle(a6),JPEGCurrentProcess
 lea DSPStruct(a6),a0
 move.l #JPEGDDSPStruct,d0
 lsr.l #2,d0
 bsr.s DSPBlkUnpacked
 sf DSPBusyFlag
 movem.l (sp)+,d0/a0
 rts

;	 #] Send DSP Decoder Struct: 
;	 #[ DSP Lock:

DSPLock:
 movem.l d1-d2/a0-a2,-(sp)
 move.w #$68,-(sp)
 trap #$e
 addq.w #2,sp
 and.w #DSPBUSY,d0
 movem.l (sp)+,d1-d2/a0-a2
 rts

;	 #] DSP Lock: 
;	 #[ DSP Unlock:

DSPUnlock:
 movem.l d0-d2/a0-a2,-(sp)
 move.w #$69,-(sp)
 trap #$e
 addq.w #2,sp
 movem.l (sp)+,d0-d2/a0-a2
 rts

;	 #] DSP Unlock: 
;	 #[ DSP BlkUnpacked:
;
; IN:
; A0 = Buffer Pointer
; D0 = Buffer Size in LongWords
DSPBlkUnpacked:
 movem.l d0-d2/a0-a2,-(sp)
 clr.l -(sp)
 clr.l -(sp)
 move.l d0,-(sp)
 move.l a0,-(sp)
 move.w #$62,-(sp)
 trap #$e
 lea $12(sp),sp
 movem.l (sp)+,d0-d2/a0-a2
 rts

;	 #] DSP BlkUnpacked: 
;  #] DSP Routines: 
;  #[ Output Routines:			; *
;	 #[ Create Output:

CreateOutput:
 moveq #NOERROR,d0
 movem.l d1-d7/a0-a6,-(sp)
 tst.w OutFlag(a6)
 beq.s .End
 move.l CreateOutputPtr(a6),d0
 beq.s .DefaultOutput
 move.l a6,a0
 jsr (d0.l)
 tst.w d0
.End:
 movem.l (sp)+,d1-d7/a0-a6
 rts

.DefaultOutput:
 lea DefaultFileName(pc),a0
 tst.l OutPointer(a6)
 beq.s .DefaultName
 move.l OutPointer(a6),a0
.DefaultName:
 bsr CreateFile
 bne.s .End
 move.w d1,OutHandle(a6)
 lea TGAHeader(pc),a0
 lea -$12(sp),sp
 move.l sp,a1
 move.l (a0)+,(a1)+
 move.l (a0)+,(a1)+
 move.l (a0)+,(a1)+
 move.l (a0)+,(a1)+
 move.w (a0),(a1)
 move.l sp,a1
 move.b OutMFDB+MFDBPixelWidth+1(a6),$c(a1)
 move.b OutMFDB+MFDBPixelWidth(a6),$d(a1)
 move.b OutMFDB+MFDBPixelHeight+1(a6),$e(a1)
 move.b OutMFDB+MFDBPixelHeight(a6),$f(a1)
 move.w OutPixelSize(a6),d0
 lsl.w #3,d0
 move.b d0,$10(a1)
 cmp.w #8,d0
 bne.s .Not8BitsTGA
.8BitsTGA:
 move.b #3,2(a1)
.Not8BitsTGA:
 move.l a1,a0
 moveq #$12,d0
 move.w OutHandle(a6),d1
 bsr WriteFile
 lea $12(sp),sp
 bne.s .End
 moveq #NOERROR,d0
 bra.s .End

;	 #] Create Output: 
;	 #[ Write Output:		; *

WriteOutput:
 tst.w d7
 bne.s .NotLastRow
 move.w YLoopCounter(a6),d0
 mulu MaxYSampling(a6),d0
 lsl.w #3,d0
 sub.w OutMFDB+MFDBPixelHeight(a6),d0
 sub.w #$10,d0
 neg.w d0
 move.w d0,OutTmpHeight(a6)
.NotLastRow:
 moveq #NOERROR,d0
 tst.w OutFlag(a6)
 beq.s .End
 movem.l d1-d7/a0-a6,-(sp)
 move.l CreateOutputPtr(a6),d0
 beq.s .DefaultOutput
 move.l a6,a0
 jsr (d0.l)
 tst.w d0
 movem.l (sp)+,d1-d7/a0-a6
.End:
 rts

.DefaultOutput:
 move.w OutPixelSize(a6),d0
 jmp .SwitchTable-4(pc,d0.w*4)

 opt o-
.SwitchTable:
 bra Output8Bits
 bra Output16Bits
 bra Output24Bits
 bra Output32Bits
 opt o+

Output8Bits:				; Y
 move.l OutTmpPointer(a6),a1
 move.w OutHandle(a6),d1		; Output File Handle
 moveq #0,d2
 move.w OutMFDB+MFDBPixelWidth(a6),d2
 moveq #0,d3
 move.w XLoopCounter(a6),d3
 mulu MaxXSampling(a6),d3
 lsl.l #3,d3				; Physical Line Size
 move.w OutTmpHeight(a6),d4		; Number of Lines in Block
 subq.w #1,d4
.Loop:
 move.l a1,a0
 move.l d2,d0
 bsr WriteFile
 bne.s .End
 add.l d3,a1				; Next Line
 dbf d4,.Loop
 moveq #NOERROR,d0
.End:
 movem.l (sp)+,d1-d7/a0-a6
 rts

Output16Bits:				; 2 Components | RGB
;
; Test Number of Components (2|3)
; In the case of 2 Components, I don't know what to do because
; the TARGA format has no '2 Components' file format.
;
 move.l OutTmpPointer(a6),a1
 move.w OutHandle(a6),d1		; Output File Handle
 moveq #0,d2
 move.w OutMFDB+MFDBPixelWidth(a6),d2
 move.w XLoopCounter(a6),d3
 mulu MaxXSampling(a6),d3
 lsl.l #4,d3				; Physical Line Size
 moveq #0,d4
 move.w OutTmpHeight(a6),d5
 subq.w #1,d5
 moveq #$1f,d7
.Loop1:
 move.l a1,a0
 move.w d2,d0				; Convert all Pixels in a Line
 subq.w #1,d0
.Loop2:
 move.w (a0),d4				; Input: Atari High Color Format
 move.w d4,d6				; D4=RRRRRGGG GG0BBBBB	D6=RRRRRGGG GG0BBBBB
 and.w d7,d4				; D4=00000000 000BBBBB	D6=RRRRRGGG GG0BBBBB
 eor.w d4,d6				; D4=00000000 000BBBBB	D6=RRRRRGGG GG000000
 lsr.w #1,d6				; D4=00000000 000BBBBB	D6=0RRRRRGG GGG00000
 or.w d6,d4				; D4=0RRRRRGG GGGBBBBB	D6=0RRRRRGG GGG00000
 ror.w #8,d4				; D4=GGGBBBBB 0RRRRRGG
 move.w d4,(a0)+			; Output: Targa High Color Format
 dbf d0,.Loop2
 move.l a1,a0
 move.l d2,d0
 add.l d0,d0				; 2 Bytes per Pixel
 bsr WriteFile				; Write a Line
 bne.s .End
 add.l d3,a1				; Next Line
 dbf d5,.Loop1
 moveq #NOERROR,d0
.End:
 movem.l (sp)+,d1-d7/a0-a6
 rts

Output24Bits:				; RGB
 move.l OutTmpPointer(a6),a1
 move.w OutHandle(a6),d1		; Output File Handle
 moveq #0,d2
 move.w OutMFDB+MFDBPixelWidth(a6),d2
 move.w XLoopCounter(a6),d3
 mulu MaxXSampling(a6),d3
 mulu #3,d3
 lsl.l #3,d3				; Physical Line Size
 move.w OutTmpHeight(a6),d5
 subq.w #1,d5
.Loop1:
 move.l a1,a0
 move.w d2,d0				; Convert all Pixels in a Line
 subq.w #1,d0
.Loop2:
 move.b (a0),d4
 move.b 2(a0),(a0)
 move.b d4,2(a0)			; BBBBBBBBGGGGGGGGRRRRRRRR
 addq.w #3,a0
 dbf d0,.Loop2
 move.l a1,a0
 move.l d2,d0
 mulu #3,d0				; 3 Bytes per Pixel
 bsr WriteFile
 bne.s .End
 add.l d3,a1				; Next Line
 dbf d5,.Loop1
 moveq #NOERROR,d0
.End:
 movem.l (sp)+,d1-d7/a0-a6
 rts

Output32Bits:				; RGB
 move.l OutTmpPointer(a6),a1
 move.w OutHandle(a6),d1		; Output File Handle
 moveq #0,d2
 move.w OutMFDB+MFDBPixelWidth(a6),d2
 move.w XLoopCounter(a6),d3
 mulu MaxXSampling(a6),d3
 lsl.l #5,d3				; Physical Line Size
 move.w OutTmpHeight(a6),d5
 subq.w #1,d5
.Loop1:
 move.l a1,a0
 move.w d2,d0				; Convert all Pixels in a Line
 subq.w #1,d0
.Loop2:
 move.l (a0),d4
 ror.w #8,d4
 swap d4
 ror.w #8,d4
 move.l d4,(a0)+			; BBBBBBBBVVVVVVVVRRRRRRRR
 dbf d0,.Loop2
 move.l a1,a0
 move.l d2,d0
 lsl.l #2,d0
 bsr WriteFile
 bne.s .End
 add.l d3,a1				; Next Line
 dbf d5,.Loop1
 moveq #NOERROR,d0
.End:
 movem.l (sp)+,d1-d7/a0-a6
 rts

;	 #] Write Output: 
;	 #[ Close Output:

CloseOutput:
 moveq #NOERROR,d0
 tst.w OutFlag(a6)
 beq.s .End
 move.l CloseOutputPtr(a6),d0
 beq.s .DefaultOutput
 movem.l d1-d7/a0-a6,-(sp)
 move.l a6,a0
 jsr (d0.l)
 tst.w d0
 movem.l (sp)+,d1-d7/a0-a6
.End:
 rts

.DefaultOutput:
 movem.l d1-d2/a0-a2,-(sp)
 move.w OutHandle(a6),d0
 bsr CloseFile
 not.l UserLong1(a6)			; Set User Variable (File Written and Closed)
 moveq #NOERROR,d0
 movem.l (sp)+,d1-d2/a0-a2
 rts

;	 #] Close Output: 
;	 #[ SigTerm Output:

SigTermOutput:
 tst.w OutFlag(a6)
 beq.s .End
 movem.l d0-d7/a0-a6,-(sp)
 move.l CreateOutputPtr(a6),d0
 beq.s .DefaultOutput
 move.l a6,a0
 jsr (d0.l)
 movem.l (sp)+,d0-d7/a0-a6
.End:
 rts

.DefaultOutput:
 tst.l UserLong1(a6)
 bmi.s .DoNothing			; File Correctly Written (Do Nothing)
 move.w OutHandle(a6),d0		; Output File Handle
 bmi.s .DoNothing			; File not Created (Do Nothing)
 bsr CloseFile				; Close Output File
 move.l OutPointer(a6),a0
 bsr DeleteFile				; and Delete it
.DoNothing:
 movem.l (sp)+,d0-d7/a0-a6
 rts

;	 #] SigTerm Output: 
;  #] Output Routines: 
;  #[ Memory Routines:
;	 #[ Malloc:
;
; IN:
; D0 = Block Size
; OUT:
; D0 = 0 /Error
; A0 = Block Address
Malloc:
 movem.l d1-d3/a1-a2,-(sp)
 tst.b MiNTFlag
 bne.s .Mxalloc
 addq.l #6,d0
 move.l d0,-(sp)
 move.w #$48,-(sp)
 trap #1
 addq.w #6,sp
.AfterMalloc:
 tst.l d0
 bmi.s .Error
 beq.s .Error
 btst #1,d0
 beq.s .LongEven
.WordEven:
 move.l d0,a0
 move.l d0,2(a0)
 addq.w #6,a0
 moveq #NOERROR,d0
 movem.l (sp)+,d1-d3/a1-a2
 rts
.LongEven:
 move.l d0,a0
 move.l a0,(a0)+
.End:
 moveq #NOERROR,d0
 movem.l (sp)+,d1-d3/a1-a2
 rts

.Mxalloc:
 move.w ProtectionMode(pc),d3
 move.w d3,-(sp)
 btst #3,d3
 bne.s .ChangeMode
.AllocateMemory:
 addq.l #6,d0
.ChangeMode:
 move.l d0,-(sp)
 move.w #$44,-(sp)
 trap #1
 addq.w #8,sp
 btst #3,d3
 bne.s .End
 bra.s .AfterMalloc

.Error:
 moveq #NOTENOUGHMEMORY,d0
 movem.l (sp)+,d1-d2/a1-a2
 rts

;	 #] Malloc: 
;	 #[ MFree:
;
; IN:
; A0 = Block Address
; OUT:
; D0 = 0 / Error
MFree:
 movem.l d1-d2/a0-a2,-(sp)
 move.l -4(a0),-(sp)
 move.w #$49,-(sp)
 trap #1
 addq.w #6,sp
 tst.l d0
 movem.l (sp)+,d1-d2/a0-a2
 rts

;	 #] MFree: 
;  #] Memory Routines: 
;  #[ GEM Routines:
;	 #[ Appl Init:
;
; OUT:
; D0 = IntOut(0)
ApplInit:
 movem.l d1-d2/a0-a2,-(sp)
 lea ApplInitParams(pc),a0
 bra.s AESCall

;	 #] Appl Init: 
;	 #[ Appl Exit:
;
; OUT:
; D0 = IntOut(0)
ApplExit:
 movem.l d1-d2/a0-a2,-(sp)
 lea ApplExitParams(pc),a0
 bra.s AESCall

;	 #] Appl Exit: 
;	 #[ Form Dial:
;
; OUT:
; D0 = IntOut(0)
FormDial:
 movem.l d1-d2/a0-a2,-(sp)
 lea FormDialParams(pc),a0
 bra.s AESCall

;	 #] Form Dial: 
;	 #[ Form Center:
;
; IN:
; A0 = Resource Tree
; OUT:
; D0 = IntOut(0)
FormCenter:
 movem.l d1-d2/a0-a2,-(sp)
 lea FormCenterParams(pc),a0
 bra.s AESCall

;	 #] Form Center: 
;	 #[ Objc Draw:
;
; OUT:
; D0 = IntOut(0)
ObjcDraw:
 movem.l d1-d2/a0-a2,-(sp)
 lea ObjcDrawParams(pc),a0
 bra.s AESCall

;	 #] Objc Draw: 
;	 #[ Wind Update:
;
; OUT:
; D0 = IntOut(0)
WindUpdate:
 movem.l d1-d2/a0-a2,-(sp)
 lea WindUpdateParams(pc),a0
 bra.s AESCall

;	 #] Wind Update: 
;	 #[ Graf Handle:

GrafHandle:
 movem.l d1-d2/a0-a2,-(sp)
 lea GrafHandleParams(pc),a0
;
; ... AESCall
;
;	 #] Graf Handle: 
;	 #[ AES Call:
;
; IN:
; A0 = AES Parameters List
; OUT:
; D0 = IntOut(0)
AESCall:
 lea AESControl(pc),a1
 move.w (a0)+,(a1)+
 move.w (a0)+,(a1)+
 move.w (a0)+,(a1)+
 move.w (a0),(a1)+
 clr.w (a1)
 move.w #$c8,d0
 move.l #AESPointers,d1
 trap #2
 move.w IntOut(pc),d0
 movem.l (sp)+,d1-d2/a0-a2
 rts

;	 #] AES Call: 
;	 #[ Relocate Tree:
;
; IN:
; D0 = Font Height
RelocateTree:
 move.l a0,-(sp)
 cmp.w #$10,d0
 bge.s .End
 lea JPEGDecoderBox(pc),a0
 lsr.w 22(a0)
 lsr.w 42(a0)
 lsr.w 46(a0)
 lsr.w 66(a0)
 lsr.w 70(a0)
 lsr.w 90(a0)
 lsr.w 94(a0)
.End:
 move.l (sp)+,a0
 rts

;	 #] Relocate Tree: 
;  #] GEM Routines: 
;  #[ Disk Routines:
;	 #[ Create File:
;
; IN:
; A0 = FileName Pointer
; OUT:
; D0 = 0 / Error
; D1 = File Handle
CreateFile:
 movem.l d2/a0-a2,-(sp)
 clr.w -(sp)
 move.l a0,-(sp)
 move.w #$3c,-(sp)
 trap #1
 addq.w #8,sp
 move.w d0,d1
 smi d0
 ext.w d0
 movem.l (sp)+,d2/a0-a2
 rts

;	 #] Create File: 
;	 #[ Write File:
;
; IN:
; A0 = Buffer Pointer
; D0 = Buffer Size (Bytes)
; D1 = File Handle
; OUT:
; D0 = 0 / Error
WriteFile:
 movem.l d1-d3/a0-a2,-(sp)
 move.l d0,d3
 move.l a0,-(sp)
 move.l d0,-(sp)
 move.w d1,-(sp)
 move.w #$40,-(sp)
 trap #1
 lea $c(sp),sp
 tst.l d0
 bmi.s .End
 sub.l d3,d0
 sne d0
 extb.l d0
 and.l #DISKFULL,d0
.End:
 movem.l (sp)+,d1-d3/a0-a2
 rts

;	 #] Write File: 
;	 #[ Close File:
;
; IN:
; D0 = File Handle
; OUT:
; D0 = 0 / Error
CloseFile:
 movem.l d1-d2/a0-a2,-(sp)
 move.w d0,-(sp)
 move.w #$3e,-(sp)
 trap #1
 addq.w #4,sp
 tst.w d0
 movem.l (sp)+,d1-d2/a0-a2
 rts

;	 #] Close File: 
;	 #[ Delete File:
;
; IN:
; A0 = FileName Pointer
DeleteFile:
 movem.l d0-d2/a0-a2,-(sp)
 move.l a0,-(sp)
 move.w #$41,-(sp)
 trap #1
 addq.w #6,sp
 movem.l (sp)+,d0-d2/a0-a2
 rts

;	 #] Delete File: 
;  #] Disk Routines: 
;  #[ MC68030 Padding:

TEXTEND:
 IFNE (TEXTEND-TEXTSTART)&2
 dc.w 0
 ENDC

;  #] MC68030 Padding: 
 DATA
;  #[ MC68030 Padding:

DATASTART:

;  #] MC68030 Padding: 
;  #[ Default Gamma Table:

DefaultGammaTable:
 dc.b $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0a,$0b,$0c,$0d,$0e,$0f
 dc.b $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1a,$1b,$1c,$1d,$1e,$1f
 dc.b $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2a,$2b,$2c,$2d,$2e,$2f
 dc.b $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3a,$3b,$3c,$3d,$3e,$3f
 dc.b $40,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4a,$4b,$4c,$4d,$4e,$4f
 dc.b $50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5a,$5b,$5c,$5d,$5e,$5f
 dc.b $60,$61,$62,$63,$64,$65,$66,$67,$68,$69,$6a,$6b,$6c,$6d,$6e,$6f
 dc.b $70,$71,$72,$73,$74,$75,$76,$77,$78,$79,$7a,$7b,$7c,$7d,$7e,$7f
 dc.b $80,$81,$82,$83,$84,$85,$86,$87,$88,$89,$8a,$8b,$8c,$8d,$8e,$8f
 dc.b $90,$91,$92,$93,$94,$95,$96,$97,$98,$99,$9a,$9b,$9c,$9d,$9e,$9f
 dc.b $a0,$a1,$a2,$a3,$a4,$a5,$a6,$a7,$a8,$a9,$aa,$ab,$ac,$ad,$ae,$af
 dc.b $b0,$b1,$b2,$b3,$b4,$b5,$b6,$b7,$b8,$b9,$ba,$bb,$bc,$bd,$be,$bf
 dc.b $c0,$c1,$c2,$c3,$c4,$c5,$c6,$c7,$c8,$c9,$ca,$cb,$cc,$cd,$ce,$cf
 dc.b $d0,$d1,$d2,$d3,$d4,$d5,$d6,$d7,$d8,$d9,$da,$db,$dc,$dd,$de,$df
 dc.b $e0,$e1,$e2,$e3,$e4,$e5,$e6,$e7,$e8,$e9,$ea,$eb,$ec,$ed,$ee,$ef
 dc.b $f0,$f1,$f2,$f3,$f4,$f5,$f6,$f7,$f8,$f9,$fa,$fb,$fc,$fd,$fe,$ff

;  #] Default Gamma Table: 
;  #[ Huffman Tables:
;	 #[ Inverse ZIGZAG Matrix:

InverseZIGZAGMatrix:
 dc.l 00*2,01*2,08*2,16*2,09*2,02*2,03*2,10*2
 dc.l 17*2,24*2,32*2,25*2,18*2,11*2,04*2,05*2
 dc.l 12*2,19*2,26*2,33*2,40*2,48*2,41*2,34*2
 dc.l 27*2,20*2,13*2,06*2,07*2,14*2,21*2,28*2
 dc.l 35*2,42*2,49*2,56*2,57*2,50*2,43*2,36*2
 dc.l 29*2,22*2,15*2,23*2,30*2,37*2,44*2,51*2
 dc.l 58*2,59*2,52*2,45*2,38*2,31*2,39*2,46*2
 dc.l 53*2,60*2,61*2,54*2,47*2,55*2,62*2,63*2

;	 #] Inverse ZIGZAG Matrix: 
;	 #[ Padding Table:

PaddingTable:
 dc.w %0000000000000000,%1111111111111111
 dc.w %0000000000000000,%1111111111111101
 dc.w %0000000000000000,%1111111111111001
 dc.w %0000000000000000,%1111111111110001
 dc.w %0000000000000000,%1111111111100001
 dc.w %0000000000000000,%1111111111000001
 dc.w %0000000000000000,%1111111110000001
 dc.w %0000000000000000,%1111111100000001
 dc.w %0000000000000000,%1111111000000001
 dc.w %0000000000000000,%1111110000000001
 dc.w %0000000000000000,%1111100000000001

;	 #] Padding Table: 
;	 #[ Huffman Padding Table:

HuffmanPaddingTable:
 dc.w 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 dc.w 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 dc.w 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 dc.w 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 dc.w 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 dc.w 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 dc.w 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 dc.w 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 dc.w 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 dc.w 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 dc.w 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 dc.w 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 dc.w 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 dc.w 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 dc.w 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 dc.w 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1

;	 #] Huffman Padding Table: 
;  #] Huffman Tables: 
;  #[ Interlacing Tables:
;	 #[ Interlacing Routine Tables:

InterlacingRoutinePointers:
 dc.l Interlace1ByteMCU
 dc.l Interlace2BytesMCU
 dc.l Interlace3BytesMCU
 dc.l Interlace4BytesMCU

;	 #] Interlacing Routine Tables: 
;	 #[ Interlacing Offset Tables:

InterlacingOffsetPointers:
 dc.l X1Y1Table
 dc.l X1Y2Table
 dc.l X1Y3Table
 dc.l X1Y4Table
 dc.l X2Y1Table
 dc.l X2Y2Table
 dc.l X2Y3Table
 dc.l X2Y4Table
 dc.l X3Y1Table
 dc.l X3Y2Table
 dc.l X3Y3Table
 dc.l X3Y4Table
 dc.l X4Y1Table
 dc.l X4Y2Table
 dc.l X4Y3Table
 dc.l X4Y4Table

X1Y1Table:
 dc.w 0,0

X1Y2Table:
 dc.w 0,0,0,1

X1Y3Table:
 dc.w 0,0,0,1,0,2

X1Y4Table:
 dc.w 0,0,0,1,0,2,0,3

X2Y1Table:
 dc.w 0,0,1,0

X2Y2Table:
 dc.w 0,0,1,0,0,1,1,1

X2Y3Table:
 dc.w 0,0,1,0,0,1,1,1,0,2,1,2

X2Y4Table:
 dc.w 0,0,1,0,0,1,1,1,0,2,1,2,0,3,1,3

X3Y1Table:
 dc.w 0,0,1,0,2,0

X3Y2Table:
 dc.w 0,0,1,0,2,0,0,1,1,1,2,1

X3Y3Table:
 dc.w 0,0,1,0,2,0,0,1,1,1,2,1,0,2,1,2,2,2

X3Y4Table:
 dc.w 0,0,1,0,2,0,0,1,1,1,2,1,0,2,1,2,2,2,0,3,1,3,2,3

X4Y1Table:
 dc.w 0,0,1,0,2,0,3,0

X4Y2Table:
 dc.w 0,0,1,0,2,0,3,0,0,1,1,1,2,1,3,1

X4Y3Table:
 dc.w 0,0,1,0,2,0,3,0,0,1,1,1,2,1,3,1,0,2,1,2,2,2,3,2

X4Y4Table:
 dc.w 0,0,1,0,2,0,3,0,0,1,1,1,2,1,3,1,0,2,1,2,2,2,3,2,0,3,1,3,2,3,3,3

;	 #] Interlacing Offset Tables: 
;  #] Interlacing Tables: 
;  #[ DSP Tables:
;	 #[ DSP SendMCU Table:

DSPSendMCUTable:
 dc.b SEND8BITSY
 dc.b SEND16BITSRGB
 dc.b SEND24BITSRGB
 dc.b SEND32BITSRGB

 dc.b -1
 dc.b -1
 dc.b -1
 dc.b -1

 dc.b SEND8BITSY
 dc.b SEND16BITSRGB
 dc.b SEND24BITSRGB
 dc.b SEND32BITSRGB

 dc.b -1
 dc.b -1
 dc.b -1
 dc.b -1

 even

;	 #] DSP SendMCU Table: 
;	 #[ DSP ConvertMCU Table:

DSPConvertMCUTable:
 dc.b YTOY
 dc.b -1
 dc.b YTORGB
 dc.b YTORGB

 dc.b -1
 dc.b -1
 dc.b -1
 dc.b -1

 dc.b YCBCRTOY
 dc.b -1
 dc.b YCBCRTORGB
 dc.b YCBCRTORGB

 dc.b -1
 dc.b -1
 dc.b -1
 dc.b -1

 even

;	 #] DSP ConvertMCU Table: 
;	 #[ DSP ExpandDU Table:

DSPExpandDUTable:
 dc.l X1Y1Pointer
 dc.l X1Y2Pointer
 dc.l X1Y3Pointer
 dc.l X1Y4Pointer
 dc.l X2Y1Pointer
 dc.l X2Y2Pointer
 dc.l X2Y3Pointer
 dc.l X2Y4Pointer
 dc.l X3Y1Pointer
 dc.l X3Y2Pointer
 dc.l X3Y3Pointer
 dc.l X3Y4Pointer
 dc.l X4Y1Pointer
 dc.l X4Y2Pointer
 dc.l X4Y3Pointer
 dc.l X4Y4Pointer

X1Y1Pointer:
 dc.b X1Y1_X1Y1

X1Y2Pointer:
 dc.b X1Y2_X1Y2,X1Y2_X1Y1

X1Y3Pointer:
 dc.b X1Y3_X1Y3,NOSUBSAMP,X1Y3_X1Y1

X1Y4Pointer:
 dc.b X1Y4_X1Y4,X1Y4_X1Y2,NOSUBSAMP,X1Y4_X1Y1

X2Y1Pointer:
 dc.b X2Y1_X2Y1
 dc.b X2Y1_X1Y1

X2Y2Pointer:
 dc.b X2Y2_X2Y2,X2Y2_X2Y1
 dc.b X2Y2_X1Y2,X2Y2_X1Y1

X2Y3Pointer:
 dc.b X2Y3_X2Y3,NOSUBSAMP,X2Y3_X2Y1
 dc.b X2Y3_X1Y3,NOSUBSAMP,X2Y3_X1Y1

X2Y4Pointer:
 dc.b X2Y4_X2Y4,X2Y4_X2Y2,NOSUBSAMP,X2Y4_X2Y1
 dc.b X2Y4_X1Y4,X2Y4_X1Y2,NOSUBSAMP,X2Y4_X1Y1

X3Y1Pointer:
 dc.b X3Y1_X3Y1
 dc.b NOSUBSAMP
 dc.b X3Y1_X1Y1

X3Y2Pointer:
 dc.b X3Y2_X3Y2,X3Y2_X3Y1
 dc.b NOSUBSAMP,NOSUBSAMP
 dc.b X3Y2_X1Y2,X3Y2_X1Y1

X3Y3Pointer:
 dc.b X3Y3_X3Y3,NOSUBSAMP,X3Y3_X3Y1
 dc.b NOSUBSAMP,NOSUBSAMP,NOSUBSAMP
 dc.b X3Y3_X1Y3,NOSUBSAMP,X3Y3_X1Y1

X3Y4Pointer:
 dc.b X3Y4_X3Y4

X4Y1Pointer:
 dc.b X4Y1_X4Y1
 dc.b X4Y1_X2Y1
 dc.b NOSUBSAMP
 dc.b X4Y1_X1Y1

X4Y2Pointer:
 dc.b X4Y2_X4Y2,X4Y2_X4Y1
 dc.b X4Y2_X2Y2,X4Y2_X2Y1
 dc.b NOSUBSAMP,NOSUBSAMP
 dc.b X4Y2_X1Y2,X4Y2_X1Y1

X4Y3Pointer:
 dc.b X4Y3_X4Y3

X4Y4Pointer:
 dc.b X4Y4_X4Y4

 even

;	 #] DSP ExpandDU Table: 
;	 #[ DSP Dequantization Table:

DSPDequantizationTable:
 dc.l MATRIX1
 dc.l MATRIX2
 dc.l MATRIX3
 dc.l MATRIX4

;	 #] DSP Dequantization Table: 
;  #] DSP Tables: 
;  #[ DSP Code:

DSPCode:
 incbin JPEGD.BIN
DSPEndCode:

 even

;  #] DSP Code: 
;  #[ Output Datas:

TGAHeader:
 dc.b $00,$00,$02,$00,$00,$00,$00,$00,$00
 dc.b $00,$00,$00,$00,$00,$00,$00,$00,$20

DefaultFileName:
 dc.b 'OUTPUT.TGA',0
 even

;  #] Output Datas: 
;  #[ TOS Strings:

JPEGDecoderTxt:
 dc.b 'p'
 dc.b '     FALCON-030 JPEG Decoder v0.81     ',$d,$a
 dc.b '     1993 Brainstorm & Atari Corp.     ',$d,$a
 dc.b 'q',0

 IFNE ENGLISH
DecoderReadyTxt:
 dc.b '         JPEG decoder installed         ',$d,$a,0
InvalidHardwareTxt:
 dc.b '     Invalid hardware configuration     ',$d,$a,0
CookieErrorTxt:
 dc.b '     JPEG decoder already installed     ',$d,$a,0
MemoryErrorTxt:
 dc.b '           Not enough memory!           ',$d,$a,0
 ENDC

 IFNE FRENCH
 fail
 ENDC

 IFNE GERMAN
 fail
 ENDC

 IFNE ITALIAN
 fail
 ENDC

 IFNE SPANISH
 fail
 ENDC

 even

;  #] TOS Strings: 
;  #[ GEM Datas:

AESPointers:
 dc.l AESControl
 dc.l Global
 dc.l IntIn
 dc.l IntOut
 dc.l AddrIn
 dc.l AddrOut

ApplInitParams:
 dc.w 10,0,1,0
ApplExitParams:
 dc.w 19,0,1,0
FormDialParams:
 dc.w 51,9,1,0
FormCenterParams:
 dc.w 54,0,5,1
ObjcDrawParams:
 dc.w 42,6,1,1
WindUpdateParams:
 dc.w 107,1,1,0
GrafHandleParams:
 dc.w 77,0,5,0

;  #] GEM Datas: 
;  #[ GEM Resource:

RsString0:
 dc.b 'FALCON030 JPEG Decoder v0.81',0
RsString1:
 dc.b '1993 Brainstorm & Atari Corp.',0
 IFNE ENGLISH
RsString2:
 dc.b 'Decoder Ready',0
RsString3:
 dc.b 'Invalid hardware',0
RsString4:
 dc.b 'Decoder already installed',0
RsString5:
 dc.b 'Not enough memory!',0
 ENDC

 IFNE FRENCH
 fail
 ENDC

 IFNE GERMAN
 fail
 ENDC

 IFNE ITALIAN
 fail
 ENDC

 IFNE SPANISH
 fail
 ENDC

RsEmptyString:
 dc.b 0

 even

RsTedinfo0:
 dc.l RsString0
 dc.l RsEmptyString
 dc.l RsEmptyString
 dc.w 3,$0000,2,$1100,$0000,0,29,1
RsTedinfo1:
 dc.l RsString1
 dc.l RsEmptyString
 dc.l RsEmptyString
 dc.w 3,$0000,2,$1100,$0000,0,31,1
RsTedinfo2:
 dc.l 0					; Dynamic String
 dc.l RsEmptyString
 dc.l RsEmptyString
 dc.w 3,$0000,2,$1100,$0000,0,14,1

JPEGDecoderBox:
 dc.w -1,1,3,20,$400,$10
 dc.l $021100
 dc.w 0,0,256,112
RsObject0:
 dc.w 2,-1,-1,21,$0,$0
 dc.l RsTedinfo0
 dc.w 0,16,256,16
RsObject1:
 dc.w 3,-1,-1,21,$400,$0
 dc.l RsTedinfo1
 dc.w 0,48,256,16
RsObject2:
 dc.w 0,-1,-1,21,$420,$0
 dc.l RsTedinfo2
 dc.w 0,80,256,16

;  #] GEM Resource: 
;  #[ MC68030 Padding:

DATAEND:
 IFNE (DATAEND-DATASTART)&2
 dc.w 0
 ENDC

;  #] MC68030 Padding: 
 BSS
;  #[ Stack:

 ds.l 1000
MyStack:
 ds.l 1

;  #] Stack: 
;  #[ GEM BSS:

AESControl:
 ds.w 15
Global:
 ds.w 80
IntIn:
 ds.w 128
IntOut:
 ds.w 45
AddrIn:
 ds.l 128
AddrOut:
 ds.l 6

;  #] GEM BSS: 
;  #[ Decoder BSS:

TOSStringPtr:
 ds.l 1

ReturnCode:
 ds.w 1
ReturnValue:
 ds.l 1

JPEGProcessNumber:
 ds.w 1

JPEGProcessHandles:
 ds.b 32

JPEGCurrentProcess:
 ds.w 1

GammaBuffer:
 ds.l $202				; Command (3) + Gamma Address + Gamma Table

ProtectionMode:				; Mxalloc Mode (Used Under MiNT)
 ds.w 1

MiNTFlag:
 ds.b 1

DSPBusyFlag:				; Internal Semaphore (Useful under MiNT)
 ds.b 1

 even

;  #] Decoder BSS: 
 END
